<?php 
include_once "htmllib/lib/include.php";
include_once "lib/updatelib.php";
include_once "htmllib/lib/updatelib.php";

function updatecleanup_main()
{
	global $argc, $argv;
	global $gbl, $sgbl, $login, $ghtml; 

	$program = $sgbl->getProductName();
	$opt = parse_opt($argv);

	if ($opt['type'] === 'master') 
	{
		initProgram('admin');
		
		$flg = "__path_program_start_vps_flag";
		
		if (!lxfile_exists($flg)) 
		{
			set_login_skin_to_feather();
		}
	} 
	else 
	{
		$login = new Client(null, null, 'update');
	}

	echo 'Executing UpdateCleanup. This can take some time. Please be patient.' . PHP_EOL;
	log_log("update", "Executing Updatecleanup");
	
	//
	// Check for lxlabs yum repo file and if exists
	// Change to lxcenter repo file
	//
	if (lxfile_exists("/etc/yum.repos.d/lxlabs.repo")) 
	{
		print("Delete old repo's\n");
		lxfile_mv("/etc/yum.repos.d/lxlabs.repo","/etc/yum.repos.d/lxlabs.repo.lxsave");
		system("rm -f /etc/yum.repos.d/lxlabs.repo");
		print("Removed lxlabs.repo\n");
		
		print("Installing lxcenter.repo\n");
		system("wget -O /etc/yum.repos.d/lxcenter.repo http://download.lxcenter.org/lxcenter.repo");
		
        print("Installing yum-protectbase plugin\n");
        system("yum install -y -q yum-protectbase");
		print("Done.\n");
	}
	//
	
	//
	// Fix vulnerability within webmail
	// If the flag isn't found, run the fix
	//
	// Disabled in Kloxo 6.1.4
	//if (!lxfile_exists("/usr/local/lxlabs/kloxo/file/webmailReset")) {
	//	system("/usr/local/lxlabs/ext/php/php /usr/local/lxlabs/kloxo/bin/misc/secure-webmail-mysql.phps");
	//	system("/bin/rm /usr/local/lxlabs/kloxo/bin/misc/secure-webmail-mysql.phps");
	//}
	
	// Remove Flagfile in Kloxo 6.1.4, this can be removed in 6.1.4+
	/*if (lxfile_exists("/usr/local/lxlabs/kloxo/file/webmailReset")) {
	      system("/bin/rm /usr/local/lxlabs/kloxo/file/webmailReset");
	}*/

	// Fix #388 - phpMyAdmin config.inc.php permission
	echo 'Checking phpMyAdmin config.inc.php permission' . PHP_EOL;
	
    $correct_perm = '0644';
    
    $phpmyadmin_config_file = "/usr/local/lxlabs/$program/httpdocs/thirdparty/phpMyAdmin/config.inc.php";
    
    if(lxfile_exists($phpmyadmin_config_file))
    {
	    $check_perm = substr(decoct(fileperms($phpmyadmin_config_file) ), 2);
	
	    if ($check_perm != $correct_perm) {
	        lxfile_unix_chmod($phpmyadmin_config_file, '0644');
	    }
    }

	if (lxfile_exists('.svn') || lxfile_exists('.git') /*|| lxfile_exists('.bzr')*/) 
	{
		echo 'Development version found. Exiting.' . PHP_EOL;
		exit;
	}

	// If master it will update all the slave for that master
	if ($opt['type'] === 'master') 
	{
		$sgbl->slave = false;
		
		if (!is_secondary_master()) 
		{
			updateDatabaseProperly();
			fixExtraDB();
			doUpdateExtraStuff();
			lxshell_return('__path_php_path', '../bin/common/driverload.php');
		}
		
		update_all_slave();
		cp_dbfile();
	} 
	else 
	{
		$sgbl->slave = true;
	}

	// Update himself if is not a secondary master
	if (!is_secondary_master()) 
	{
		echo 'Running update cleanup on main master ...' . PHP_EOL;
    
	    $program = $sgbl->getProductName();
	    
	    $updater = new Updater();
	    $updater->createProgramService($program); //For kloxo right way
	    $updater->createProgramService('qpanel'); //Temporal for qpanel
	    $updater->copyPHPini();
	    
	    $updater->restartInitProgram($program);
	    $updater->restartInitProgram('qpanel');
	    
	    $updater->downloadThirparty();
	
	    $updater->installPHPgd();
	    $updater->installBogofilter();
	    $updater->migrateClientsDir();
	    $updater->checkPhpMyAdminConfig();
	    
		os_updateApplicableToSlaveToo();
		
		$updater->prepareDefaultDir();
	}

	lxfile_touch('__path_program_start_vps_flag');
}

function cp_dbfile()
{
	global $gbl, $sgbl, $login, $ghtml;

	$progname = $sgbl->getProductName();

	lxfile_cp("../sbin/{$progname}db", "/usr/bin/{$progname}db");
	lxfile_generic_chmod("/usr/bin/{$progname}db", "0755");
}

exit_if_another_instance_running();
debug_for_backend();
updatecleanup_main();