<?php
function createServerName($admin_pass = NULL)
{
    $production_server = new pserver(null, 'localhost', 'localhost');
    $production_server->initThisDef();
    $production_server->rolelist = array('web', 'ns');
    
    if(if_demo())
    {
        $production_server->realpass = 'admin';
        $production_server->password = crypt('admin');
        $production_server->cpstatus = 'on';
    }
    else 
    {
    	$production_server->realpass = $admin_pass;
    	$production_server->password = crypt($admin_pass);
    	$production_server->cpstatus = 'on';
    }
    
    $production_server->dbaction = 'add';
    $production_server->postAdd();
    $production_server->superPostAdd();
    $production_server->was();
    
    //dprintr($production_server);
    return;
}

function createDefaultDomainTemplate($dns)
{
    global $gbl, $sgbl, $login, $ghtml; 

    $template = new Domaintemplate(null, null, 'test');
    $template->initThisDef();
    $template->dbaction = 'add';
    $template->ipaddress = $dns->webipaddress;
    $lispriv = new Listpriv(null, null, 'test');
    $listpriv->webpserver_sing = 'localhost';
    $listpriv->mmailpserver_sing = 'localhost';
    $listpriv->dnspserver_sing = 'localhost';
    $listpriv->secdnspserver_sing = '--Disabled--';
    $template->listpriv = $listpriv;
    $template->dnstemplate = $dns->nname;
    // The listpriv used to get to initialized here....
    $template->parent_clname = 'client-admin';
    $template->description = 'The Default Template created Only in debug Mode';
    $template->write();
}

function createDnsTemplate()
{
    global $gbl, $sgbl, $login, $ghtml; 
    if ($sgbl->getDebugLevel() < 1) return;

    $ip = getOneIPForLocalhost('something');
    $dns_template = new DnsTemplate(null, null, 'test');
    $dns_template->nameserver_f = 'ns.lxlabs.com';
    $dns_template->webipaddress = $ip;
    $dns_template->mmailipaddress = $ip;
    $dns_template->parent_clname = $login->getClName();
    $dns_template->shared = 'on';
    $dns_template->dbaction = 'add';
    $dns_template->postAdd();
    $dns_template->was();
    createDefaultDomainTemplate($dns_template);
}

function init_main($admin_pass)
{
    global $gbl, $sgbl, $login, $ghtml; 

    try
    {
        add_admin($admin_pass);
        initProgram('admin');

        createServerName($admin_pass);
        //createDefaultDomainTemplate();

        $login->was();
        createDnsTemplate();
        Ticket::createWelcomeTicket();
        /*
        if (lxfile_exists("__path_program_etc/license.txt")) {
            decodeAndStoreLicense();
            $login->license_o->write();
            $login->write();
        }
    */
    }
    catch (Exception $e)
    {
        echo $e->getMessage() . "\\n\n\n\n\n\n\n\n\n\nn\n";
    }
    echo "\n";
}