<?php
# Note: current path for load files is 'httpdocs'
require_once 'exceptions/lxException.php';

include_once 'htmllib/lib/linux/lib.php';
include_once 'lib/linux/program.php';

// Don't remove this. This is used for slave upgrade on htmllib/lib/updatelib.php.
function remotetestfunc()
{

}

define('S_IFDIR', 00040000);
define('S_ISUID', 00004000);
define('S_ISGID', 00002000);

require_once('lib/sgbl.php');

function check_for_debug($file)
{
	/* Check for Development/Debug version
	 If file not exists, Production mode (-1)
	If file exists it can have the following numbers to enable
	1  = Debug mode 1
	2  = Debug mode 2
	3  = Debug mode 3
	4  = Debug mode 4
	5  = Debug mode 5
	-1 = Turn Off and go to production mode */

	global $gbl, $sgbl, $login, $ghtml;

	require_once 'htmllib/lib/commonfslib.php';
	require_once 'htmllib/lib/includecore.php';

	if(lxfile_exists(getreal($file)))
	$sgbl->setDebug(intval(lfile_get_contents(getreal($file))));
	else  #[FIXME] Use $sgbl::PRODUCTION_MODE instead -1 when we can use PHP 5.3.0
	$sgbl->setDebug(-1);
	 
	if($sgbl->isDebug())
	{
		ini_set('error_reporting', E_ALL & ~E_STRICT);
		ini_set('display_errors', 'On');
		ini_set('log_errors', 'On');
	}
	else
	{
		ini_set('error_reporting', E_ERROR);
		ini_set('display_errors', 'Off');
		ini_set('log_errors', 'On');
	}
}

function debug_for_backend()
{
	global $gbl, $sgbl, $login, $ghtml;
	check_for_debug('/commands.php');
	if($sgbl->isDebug()) return;
	check_for_debug('/backend.php');
}

function isUpdating()
{
	return lx_core_lock_check_only('update.php');
}

function getAllOperatingSystemDetails()
{
	$ret = findOperatingSystem();
	$ret['loadavg'] = os_getLoadAvg();
	dprintr($ret);
	return $ret;
}

function findOperatingSystem($type = null)
{
	if(file_exists('/etc/fedora-release'))
	{
		$data['os'] = 'fedora';
		$data['version'] = file_get_contents('/etc/fedora-release');
		$data['pointversion'] = find_os_pointversion();
	}
	elseif(file_exists('/etc/redhat-release'))
	{
		$data['os'] = 'rhel';
		$data['version'] = file_get_contents('/etc/redhat-release');
		$data['pointversion'] = find_os_pointversion();
	}

	/* [FIXME] Not sure that it is used on qpanel
	 if(lxfile_exists($sgbl->getEtc() . 'install_xen') || lxfile_exists('/proc/xen'))
	{
	$data['vpstype'] = 'xen';
	$data['xenlocation'] = vg_complete();
	}*/

	if($type) return $data[$type];

	return $data;
}

function find_os_pointversion()
{
	if (file_exists("/etc/fedora-release")) {
		$release = trim(file_get_contents("/etc/fedora-release"));
		$osv = explode(" ", $release);
		if (strtolower($osv[1]) === 'core') {
			$osversion = "fedora-" . $osv[3];
		} else {
			$osversion = "fedora-" . $osv[2];
		}
		return $osversion;
	}

	if (file_exists("/etc/redhat-release")) {
		$release = trim(file_get_contents("/etc/redhat-release"));
		$osv = explode(" ", $release);
		if (isset($osv[6])) {
			$osversion = "rhel-" . $osv[6];
		} else {
			$oss = explode(".", $osv[2]);
			$osversion = "centos-" . $oss[0];
		}
		return $osversion;
	}
}

function lscandir_without_dot($arg, $dotflag = false)
{
	$list = lscandir($arg);

	if (!$list) {
		return $list;
	}

	foreach ($list as $k => $v) {
		if ($v === ".." || $v === "." || $v === '.svn') {
			unset($list[$k]);
		}
		if ($dotflag && csb($v, '.')) {
			unset($list[$k]);
		}
	}
	return $list;
}

function lscandir_without_dot_or_underscore($arg, $dotflag = false)
{
	$list = lscandir($arg);

	if (!$list) {
		return $list;
	}

	foreach ($list as $k => $v) {
		if ($v === ".." || $v === "." || $v === '.svn') {
			unset($list[$k]);
		}
		if ($dotflag && csb($v, '.')) {
			unset($list[$k]);
		}
		if (csb($v, "__")) {
			unset($list[$k]);
		}
	}
	return $list;
}

function lscandir($arg)
{
	return lx_redefine_func("scandir", $arg);
}

function lunlink($arg)
{
	return lx_redefine_func("unlink", $arg);
}

function ltouch($arg)
{
	return lx_redefine_func("touch", $arg);
}

function lchdir($arg)
{
	return lx_redefine_func("chdir", $arg);
}

function takeToStartOfLine($fp)
{
	while (fgetc($fp) == "\n" && ftell($fp) != 1 && ftell($fp) != 0) {
		fseek($fp, -2, SEEK_CUR);
	}

	while (($c = fgetc($fp)) != "\n" && ftell($fp) != 1 && ftell($fp) != 0) {
		fseek($fp, -2, SEEK_CUR);
	}
}

function tail_func($file, $lines)
{
	$fp = fopen($file, "r");

	if (!$fp) {
		return null;
	}

	dprint("in Tail Func\n");

	fseek($fp, 0, SEEK_END);

	// Go back onece and read the line.
	takeToStartOfLine($fp);
	$arr[] = fgets($fp);

	$n = 0;
	while ($n < $lines && ftell($fp) !== 1) {
		$n++;
		//dprint($n . "\n");
		// You have to go back twice.
		print(' Before: ' . ftell($fp) . "\n");
		fseek($fp, -3, SEEK_CUR);
		takeToStartOfLine($fp);
		fseek($fp, -3, SEEK_CUR);
		print(' aaFter: ' . ftell($fp) . "\n");
		takeToStartOfLine($fp);
		print(' aaaaFter: ' . ftell($fp) . "\n");
		$arr[] = fgets($fp);
	}
	return implode("", array_reverse($arr));
}

function lfile_get_json_unserialize($file)
{
	if (!lxfile_exists($file)) {
		return null;
	}
	return json_decode(lfile_get_contents($file), true);
}

function lfile_put_json_serialize($file, $var)
{
	return lfile_put_contents($file, json_encode($var));
}

function lfile_get_unserialize($file)
{
	if (!lxfile_exists($file)) {
		return null;
	}
	return unserialize(lfile_get_contents($file));
}

function lfile_put_serialize($file, $var)
{
	return lfile_put_contents($file, serialize($var));
}

function lfile_get_contents($arg)
{
	return lx_redefine_func("file_get_contents", $arg);
}

function lrename($arg1, $arg2)
{
	return lx_redefine_func("rename", $arg1, $arg2);
}

function lfopen($arg1, $arg2)
{
	return lx_redefine_func("fopen", $arg1, $arg2);
}

function lfilesize($arg)
{
	return lx_redefine_func("filesize", $arg);
}

function ltempnam($arg1, $arg2)
{
	return lx_redefine_func("tempnam", $arg1, $arg2);
}

function lfile_write_content($file, $data, $user)
{
	if (csa($user, ":")) {
		$realuser = strtil($user, ":");
	} else {
		$realuser = $user;
	}

	if (!check_file_if_owned_by($file, $realuser)) {
		return;
	}
	lfile_put_contents($file, $data);
	lxfile_unix_chown($file, $user);
}

function check_file_if_owned_by_and_throw($filename, $username)
{
	if (!check_file_if_owned_by($filename, $username)) {
		throw new lxexception('file_exists_not_owned', '', $filename);
	}
}

function lis_hardlink($file)
{
	$file = expand_real_root($file);
	if (is_dir($file)) {
		return false;
	}
	$stat = stat($file);
	if ($stat['nlink'] >= 2) {
		return true;
	}
	return false;
}

function is_soft_or_hardlink($file)
{
	if (!lxfile_exists($file)) {
		return false;
	}

	if (lis_link($file) || lis_hardlink($file)) {
		return true;
	}
	return false;
}

function new_process_mv_rec($user, $src, $dst)
{
	$src = expand_real_root($src);
	$dst = expand_real_root($dst);
	new_process_cmd($user, null, "mv $src $dst");
}

function new_process_chmod_rec($user, $file, $perm)
{
	$file = expand_real_root($file);
	$cmd = "chmod -R $perm '$file'";
	new_process_cmd($user, null, $cmd);
}

function new_process_cp_rec($user, $src, $dst)
{
	$src = expand_real_root($src);
	$dst = expand_real_root($dst);
	$cmd = "cp -a '$src' '$dst'";
	new_process_cmd($user, null, $cmd);
}

function new_process_cmd($user, $dir, $cmd)
{
	global $sgbl;

	if (csa($user, ':')) {
		list($user, $group) = explode(':', $user);
	} else {
		$group = $user;
	}

	if ($user === 'root') {
		$user = '__system__';
	}

	if ($dir) {
		$olddir = getcwd();
		chdir($dir);
	}
	if ($user !== '__system__') {
		$uid = is_numeric($user) ? (int) $user : os_get_uid_from_user($user);
		$gid = is_numeric($group) ? (int) $group : os_get_gid_from_user($user);
		exec("{$sgbl->__path_php_path} {$sgbl->__path_program_root}/bin/phpexec.php $uid $gid $cmd 2>&1", $output, $retval);
	} else {
		exec("$cmd 2>&1", $output, $retval);
	}

	if ($dir) {
		chdir($olddir);
	}

	$output = implode("\n", $output);
	log_log('user_cmd', "($dir) $user $cmd $output");

	return $retval;
}

function lfile_put_contents($file, $data, $flag = null)
{
	$file = expand_real_root($file);

	if (is_soft_or_hardlink($file)) {
		log_log("link_error", "$file is hard or symlink. Not writing\n");
		return;
	}
	 
	if (char_search_a($data, "__path_")) {
		dprint("<font color=red>Warning : Trying to write __path into a file $file: </font> $data <br> \n", 3);
	}

	lxfile_mkdir(dirname($file));

	if(file_exists($file))
	{
		if(is_readable($file))
		{
			if(is_writable($file)){
				$result = file_put_contents($file, $data, $flag);
				chown($file, 'lxlabs');
				return $result;
			}
			else{
				$posix_data = posix_getpwuid(fileowner($file));
				$error_msg = 'Could not write the file \'' . $file . '\' with permissions: ' .
				substr(sprintf('%o', fileperms($file)), -4) .
                ' UID: ' . $posix_data['name'] .  ':' . $posix_data['uid'] .
                ' GID: ' . $posix_data['gecos'] .  ':' . $posix_data['gid'] .
				( PHP_SAPI !== 'cgi-fcgi' ? PHP_EOL : '<br />');

				dprint($error_msg);
				log_log('filesys', $error_msg);
				return false;
			}
		}
		else
		{
			$error_msg = 'Could not read the file \''.$file.'\' with permissions: '.substr(sprintf('%o', fileperms($file)), -4) . ( PHP_SAPI !== 'cgi-fcgi' ? PHP_EOL : '<br />');
			dprint($error_msg);
			log_log('filesys', $error_msg);
			return false;
		}
	}
	else
	{
		touch($file);
		$result = file_put_contents($file, $data, $flag);
		chown($file, 'lxlabs');
		 
		if($result === false)
		{
			$error_msg = 'File \''.$file.'\' could not be created.';
			dprint($error_msg);
			//log_log('filesys', $error_msg);
			return false;
		}
		return true;
	}
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc Redefining php functions ... sort of.. Stupid php doesn't allow that. So we do the next best thing.. We add an 'l' to all system functions and then use these functions instead of the php ones... In a way, is a better idea too, since, there might always be some cases where we might want to override this crap. :-)
 */
function lmkdir($dir)
{
	return lx_redefine_func("mkdir", $dir);
}

function lis_executable($file)
{
	return lx_redefine_func("is_executable", $file);
}

function lis_readable($file)
{
	return lx_redefine_func("is_readable", $file);
}

function lreadlink($file)
{
	return lx_redefine_func("readlink", $file);
}

function lis_link($file)
{
	return lx_redefine_func("is_link", $file);
}

function lis_dir($file)
{
	return lx_redefine_func("is_dir", $file);
}

function cp_if_not_exists($src, $dst)
{
	if (lxfile_exists($dst)) {
		return;
	}
	if (!lxfile_exists($src)) {
		return;
	}
	lxfile_cp($src, $dst);
}

function cp_rec_if_not_exists($src, $dst)
{
	if (lxfile_exists($dst)) {
		return;
	}
	if (!lxfile_exists($src)) {
		return;
	}
	lxfile_cp_rec($src, $dst);
}

function mv_rec_if_not_exists($src, $dst)
{
	if (lxfile_exists($dst)) {
		return;
	}
	if (!lxfile_exists($src)) {
		return;
	}
	lxfile_mv_rec($src, $dst);
}

function llstat($file)
{
	return lx_redefine_func("lstat", $file);
}

function lx_merge_good($arg)
{
	global $gbl, $sgbl, $login, $ghtml;

	$arglist = array();
	for ($i = 0; $i < func_num_args(); $i++)
	$arglist[] = func_get_arg($i);

	//dprintr($arglist);

	$list = $arglist;

	foreach ($list as &$l)
	if(!$l) $l = array();


	$ret = array();
	foreach ($list as $nl) {
		//dprintr($nl);
		if (is_array($nl)) {
			$ret = array_merge($ret, $nl);
		} else {
			$ret[] = $nl;
		}
	}
	return $ret;
}

function lx_array_merge($list)
{
	foreach ($list as &$l) {
		if (!$l) {
			$l = array();
		}
	}
	$ret = array();
	foreach ($list as $nl) {
		//dprintr($nl);
		if (is_array($nl)) {
			$ret = array_merge($ret, $nl);
		} else {
			$ret[] = $nl;
		}
	}
	return $ret;
}

function log_switch($mess, $id = 1)
{
	log_log('switch', $mess, $id);
}

function log_error($mess, $id = 1)
{
	log_log('error', $mess, $id);
}

function log_bdatabase($mess, $id = 1)
{
	log_log('bdatabase', $mess, $id);
}

function log_restore($mess, $id = 1)
{
	log_log('restore', $mess, $id);
}

function log_database($mess, $id = 1)
{
	log_log('database', $mess, $id);
}

function myPcntl_reaper()
{
	pcntl_wait($status, WNOHANG);
}

function myPcntl_wait()
{
	pcntl_wait($status);
}

function myPcntl_fork()
{
	global $gbl, $sgbl, $login, $ghtml;

	$pid = pcntl_fork();

	return $pid;
}

function log_log($file, $message, $id = NULL)
{
	if (!is_string($message))
	{
		$message = var_export($message, true);
	}

	$message = trim($message);

	$sgbl = new Sgbl();
	$root_path = $sgbl->getRoot();

	$rf = $root_path . '/log/' . $file;

	lfile_put_contents($rf, @ date('H:i M/d/Y') . ': ' . $message . PHP_EOL, FILE_APPEND);
}

function log_ajax($mess, $id = 1)
{
	log_log('ajax', $mess, $id);
}

function log_redirect($mess, $id = 1)
{
	log_log('redirect_error', $mess, $id);
}

function log_message($mess, $id = 1)
{
	log_log('message', $mess, $id);
}

function log_security($mess, $id = 1)
{
	// get IP
	if (isset($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else {
		$ip = $_SERVER['REMOTE_ADDR'];
	}

	$user_agent = $_SERVER["HTTP_USER_AGENT"];

	if (empty($_SERVER["HTTP_USER_AGENT"])) {
		$user_agent = "Not a browser";
	}

	log_log('security', $mess . " IP: $ip; User agent: $user_agent", $id);
}

function log_filesys_err($mess, $id = 1)
{
	log_log('filesyserr', $mess, $id);
}

function log_filesys($mess, $id = 1)
{
	global $global_dontlogshell;
	if ($global_dontlogshell) {
		log_log('nonfilesys', $mess, $id);
	} else {
		log_log('filesys', $mess, $id);
	}
}

function log_shell($mess, $id = 1)
{
	log_log('shell_exec', $mess, $id);
}

function log_shell_error($mess, $id = 1)
{
	log_log('shell_error', $mess, $id);
}

function lfile_trim($arg)
{
	$list = lfile($arg);
	foreach ($list as &$s) {
		$s = trim($s);
	}
	return $list;
}

function lcopy($src, $dst)
{
	return lx_redefine_func("copy", $src, $dst);
}

function lreadfile($file)
{
	return lx_redefine_func("readfile", $file);
}

function lmd5_file($file)
{
	return lx_redefine_func("md5_file", $file);
}

function lfile_exists($file)
{
	return lx_redefine_func("file_exists", $file);
}

function lsqlite_open($file)
{
	return lx_redefine_func("sqlite_open", $file);
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc This function is the core of the the path abstraction. It converts the paths of the form '__path.../dir' to '$sgbl->__path.../dir'. This is used in all the redefined functions to convert their arguments.
 */
function expand_real_root($root)
{
	global $gbl, $sgbl, $login, $ghtml;
	if (char_search_beg($root, "__path")) {
		if (char_search_a($root, "/")) {
			$var = substr($root, 0, strpos($root, "/"));
			if(!isset($sgbl->$var))
			{
				switch($var)
				{
					default:
						$root = $var;
					dprint('Error: expand_real_root: $var');
					debug_print_backtrace();
					break;
				}
			}
			else $root = ($sgbl->$var) . "/" . substr($root, strpos($root, "/") + 1);
		} else {
			$root = $sgbl->$root;
		}
	}
	$root = remove_extra_slash($root);
	return $root;
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc the function that does the redefining of fundamental file access functions.
 * Note the double use of 'eval'. hey hey, nothing is impossible in php.
 * Never ever repeat the code; Make it unreadable instead. :-)
 */
function kill_and_save_pid($name)
{
	kill_pid($name);
	usleep(50);
	save_pid($name);
}

function save_pid($name)
{
	$pid = os_getpid();
	echo 'Saving PID: ' . $pid . "\n";
	lfile_put_contents("__path_program_root/pid/$name.pid", $pid);
}

function kill_pid($name)
{
	$pid = lfile_get_contents("__path_program_root/pid/$name.pid");
	echo 'Killing process with PID: ' . $pid . "\n";
	os_killpid($pid);
}

function lx_redefine_func($func)
{
	global $gbl, $sgbl, $login, $ghtml;

	$arglist = array();
	for ($i = 1; $i < func_num_args(); $i++)
	$arglist[] = expand_real_root(func_get_arg($i));

	return call_user_func_array($func, $arglist);
}

function remove_unnecessary_stat(&$stat)
{
	foreach ($stat as $k => $v)
	if(is_numeric($k)) unset($stat[$k]);
}

function getShellCommand($cmd, $arglist)
{
	global $gbl, $sgbl, $login, $ghtml;
	$args = null;
	$q = $sgbl->__var_quote_char;
	$cmd = expand_real_root($cmd);
	$cmd = str_replace(";", "", $cmd);
	$cmd = "{$q}$cmd{$q}";

	foreach ($arglist as $a) {
		if ($a === "") {
			continue;
		}
		if (is_array($a)) {
			foreach ($a as $aa) {
				$aa = str_replace(";", "", $aa);
				$args .= " $q" . expand_real_root($aa) . "$q";
			}
		} else {
			$a = str_replace(";", "", $a);
			$args .= " $q" . expand_real_root($a) . "$q";
		}
	}
	$cmd .= " " . $args;
	return $cmd;
}

class Remote
{
	/*
	 public $ddata;
	public $message;
	public $exception;
	*/
}

function dprintoa($var, $type = 0)
{
	global $sgbl, $login, $ghtml;
	if ($type > $sgbl->getDebugLevel()) return;

	if (!is_array($var)) return;

	foreach ($var as $k => $v)
	{
		dprint("$k =>");
		dprinto($var, $type);
		dprint("\n");
	}
}

function dprinto($var, $type = 0)
{
	global $sgbl;

	if ($type > $sgbl->getDebugLevel()) return;

	if (!is_object($var)) return;

	$newob = clone($var);
	$newob->__parent_o = null;
	dprintr($newob);
}

function dprintr($var, $type = 0)
{
	global $sgbl;

	if ($type > $sgbl->getDebugLevel()) return;

	if (is_object($var) && method_exists($var, "clearChildrenAndParent"))
	{
		$newvar = myclone($var);
		lxclass::clearChildrenAndParent($newvar);
		$newvar->driverApp = 'unset for printing';
		$newvar->__parent_o = 'unset for printing';

		$class = $newvar->get__table();
		if (csb($class, "sp_")) {
			$bclass = strfrom($class, "sp_") . "_b";
			$newvar->$bclass->__parent_o = 'unset for printing';
		}
	}
	else $newvar = $var;

	print_r($newvar);
}

function dprint($var, $type = 0)
{
	global $sgbl;
	if ($type <= $sgbl->getDebugLevel())
	if(is_string($var))
	{
		print($var);
	}
}

function dprint_r($var, $type = 0)
{
	global $sgbl;
	if($type <= $sgbl->getDebugLevel()) print_r($var);
}

function lx_local_socket_read($socket)
{
	return @ socket_read($socket, 2048);
	//$res=socket_recv($MsgSock,$buffer,1024,0);
}

/**
 * char_search_a
 * @param unknown_type $haystack
 * @param unknown_type $needle
 * @param unknown_type $insensitive
 */
function csa($haystack, $needle, $insensitive = 0)
{
	return char_search_a($haystack, $needle, $insensitive);
}

function char_search_a($haystack, $needle, $insensitive = 1)
{
	if (is_array($haystack)) {
		//dprint("Got array in Char Search ");
		//dprintr($haystack);
	}

	if (is_object($haystack)) {
		$v = debugBacktrace(true);
		log_log("error", $v);
	}
	if ($insensitive) {
		return (false !== stristr($haystack, $needle)) ? true : false;
	} else {
		return (false !== strpos($haystack, $needle)) ? true : false;
	}
}

function strtil($string, $needle)
{
	if (strrpos($string, $needle) !== false) {
		return substr($string, 0, strrpos($string, $needle));
	} else {
		return $string;
	}
}

function strtilfirst($string, $needle)
{
	if (strpos($string, $needle)) {
		return substr($string, 0, strpos($string, $needle));
	} else {
		return $string;
	}
}

function strfrom($string, $needle)
{
	if (!csa($string, $needle)) {
		return $string;
	}
	return substr($string, strpos($string, $needle) + strlen($needle));
}

function array_push_unique($array, $value)
{
	if (!$array) {
		$array = array();
	}
	foreach ($array as $var) {
		if ($var === $value) {
			return $array;
		}
	}
	$array[] = $value;
	return $array;
}

function array_remove($array, $element)
{
	$ret = null;
	foreach ($array as $value) {
		if ($value !== $element) {
			$ret[] = $value;
		}
	}
	return $ret;
}

function csb($haystack, $needle, $insensitive = 1)
{
	# Char Search Begin
	return char_search_beg($haystack, $needle);
}

function char_search_beg($haystack, $needle)
{
	if (is_array($haystack)) {
		//debugBacktrace();
	}
	if (strpos($haystack, $needle) === 0) {
		return true;
	}
	return false;
}

function cse($haystack, $needle, $insensitive = 1)
{
	# Char Search End
	return char_search_end($haystack, $needle, $insensitive);
}

function char_search_end($haystack, $needle, $insensitive)
{
	if (strpos($haystack, $needle) === false) {
		return false;
	}

	if ((strrpos($haystack, $needle) + strlen($needle)) === strlen($haystack)) {
		return true;
	} else {
		return false;
	}
}

function array_search_bool($needle, $haystack)
{
	if (!$haystack) {
		return false;
	}
	if (array_search($needle, $haystack) !== false) {
		return true;
	}

	return false;
}

function remove_dot_dot($list)
{
	foreach ($list as $k => $v) {
		if ($v === "." || $v === "..") {
			unset($list[$k]);
		}
	}
	return $list;
}

function lx_tmp_file($file)
{
	global $gbl, $sgbl, $login, $ghtml;
	$file = expand_real_root($file);
	$n = preg_replace("+/+i", "_", $file);
	return tempnam("$sgbl->__path_tmp/", "lxtmp_$n");
	//return "/tmp/" . $n;
}

function lx_array_keys($list)
{
	if (!$list) {
		$list = array();
	}
	return array_keys($list);
}

function array_filter_key($full, $need)
{
	if (!$need) {
		return $full;
	}

	foreach ($full as $key => $value) {
		if (array_search_bool($key, $need)) {
			$ret[$key] = $value;
		}
	}
	return $ret;
}

function gethtmllibversion()
{
}

function isOn($var)
{
	return (($var === 'on') || ($var === 'On')) ? true : false;
}

// Function that is called to test whther the remote server is working fine or not. Used while adding.
function test_remote_func()
{
	return true;
}

function log_clicks($mess, $id = 1)
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!if_demo())
	{
		return;
	}

	$ip = $gbl->getCurrentSession()->ip_address;
	$mess = trim($mess);
	$file = "__path_program_root/log/clicks";
	lfile_put_contents($file, "$id: $ip: " . @date("H:i:s M/d/Y") . ": $mess\n", FILE_APPEND);
}

# Version Comparison Returns 1 if version1 is greater, and -1 if version2 is greater.
function version_cmp($version1, $version2)
{
	$l1 = explode(".", $version1);
	$l2 = explode(".", $version2);

	for ($i = 0; $i < 3; $i++) {
		if ($l2[$i] === $l1[$i]) {
			continue;
		}
		if ($l1[$i] > $l2[$i]) {
			return 1;
		}
		if ($l1[$i] < $l2[$i]) {
			return -1;
		}
	}
}

function app_version_cmp($version1, $version2)
{
	$l1 = explode(".", $version1);
	$l2 = explode(".", $version2);

	for ($i = 0; $i < 4; $i++) {
		if (!isset($l2[$i])) {
			$l2[$i] = 0;
		}
		if (!isset($l1[$i])) {
			$l1[$i] = 0;
		}
	}

	//dprintr($l1);
	//dprintr($l2);

	for ($i = 0; $i < 4; $i++) {
		if ($l2[$i] === $l1[$i]) {
			continue;
		}
		if ($l1[$i] > $l2[$i]) {
			return 1;
		}
		if ($l1[$i] < $l2[$i]) {
			return -1;
		}
	}
}

function fput_content_with_lock($file, $string)
{
	lfile_put_contents($file, $string);
}

function filter_object_list($list, $rule)
{
	$nlist = null;
	foreach ((array) $list as $o) {
		if ($o->eeval($rule)) {
			$nlist[$o->nname] = $o;
		}
	}
	return $nlist;
}

function is_assoc_array($var)
{
	if (!is_array($var)) {
		return false;
	}
	return array_keys($var) !== range(0, sizeof($var) - 1);
}

function get_namelist_from_objectlist($ol, $key = null, $val = null)
{
	if (!$ol) {
		return;
	}

	$name = array();
	if (!$key) {
		$key = "nname";
	}

	if ($val === null) {
		$val = $key;
	}

	foreach ($ol as $o) {
		if (!is_object($o)) {
			debugBacktrace();
		}
		$name[$o->$key] = $o->display($val);
	}
	return $name;
}

function convert_to_associate($ar)
{
	foreach ($ar as $k => $v)  $ret[$v] = $v;
	return $ret;
}

function get_namelist_from_arraylist($ol, $key = null, $val = null)
{
	$name = array();
	if (!$key) {
		$key = "nname";
	}

	if ($val === null) {
		$val = $key;
	}

	foreach ((array) $ol as $o) $name[$o[$key]] = $o[$val];

	return $name;
}

function isQuotaGreaterThanOrEq($used, $priv)
{
	if (is_unlimited($priv)) {
		return false;
	}
	if (is_unlimited($used)) {
		return true;
	}
	if (isOn($priv)) {
		return false;
	}
	if (isOn($used)) {
		return true;
	}
	return ($used >= $priv) ? true : false;
}

function isQuotaGreaterThan($used, $priv)
{
	if (is_unlimited($priv)) {
		return false;
	}
	if (is_unlimited($used)) {
		return true;
	}
	if (isOn($priv)) {
		return false;
	}
	if (isOn($used)) {
		return true;
	}
	return ($used > $priv) ? true : false;
}

function is_unlimited($val)
{
	if (strtolower($val) === 'unlimited' || strtolower($val) === 'na') {
		return true;
	}
	return false;
}

function if_demo_throw()
{
	if (if_demo()) {
		throw new lxException ("demo", '');
	}
}

function if_demo()
{
	global $gbl, $sgbl, $g_demo;
	return $g_demo;
}

function lx_phpdebug()
{
	global $gbl, $sgbl;

	if ($sgbl->dbg <= 0) {
		return;
	}
	if (!lfile_exists("/tmp/.php_debug")) {
		return;
	}

	$fp = lfopen("/tmp/.php_debug", "r");
	$s = fgets($fp, 1024);
	fclose($fp);

	$s = preg_replace("/--noraise /i", "", $s);
	$arr = parse_url($s);
	parse_str($arr['query'], $out);

	$ghtml->print_input("hidden", "start_debug", "1");
	$ghtml->print_input("hidden", "debug_port", $out['debug_port']);
	$ghtml->print_input("hidden", "debug_text_mode", "1");
	$ghtml->print_input("hidden", "debug_no_cache", "1095197145");
}

function create_simpleObject($arglist)
{
	$obj = new Remote();

	foreach ($arglist as $k => $v) {
		$obj->$k = $v;
	}
	return $obj;
}

function lx_sync()
{
	global $gbl, $sgbl, $login;
	$login->was();
}

function get_current_file()
{
	$n = basename(dirname($_SERVER['PHP_SELF']));
	return $n;
}

function array_flatten($a, $pref = null)
{
	$ret = array();
	foreach ($a as $i => $j) {
		if (is_array($j)) {
			$ret = array_merge($ret, array_flatten($j, "$pref$i"));
		} else {
			$ret["$pref$i"] = $j;
		}
	}
	return $ret;
}

function get_general_image_path($v = null)
{
	return add_http_host("/img/general/$v");
}

/**
 * @return void
 * @param
 * @param
 * @desc  part of the getting-image-through-http (to enable caching) madness.
 */
function add_http_host($elem)
{
	global $gbl, $sgbl, $login, $ghtml;
	return $elem;

	$host = $_SERVER['SERVER_NAME'];
	//$port = $sgbl->__var_prog_port;
	//$host = "http://" . $host . ":" .  "$port";
	//$host = "https://" . $host . ":" .  "$port";
	return $host . $elem;
}

function get_image_path($path = null)
{
	global $gbl, $sgbl, $login;

	//Return path of the encrypted images in the deployment version.
	# /img/image/collage//button//actionlog_list.gif
	return "/img/image/{$login->getSpecialObject('sp_specialplay')->icon_name}/$path";
}

function randomString($length)
{
	$randstr = '';
	$chars = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z');
	for ($rand = 0; $rand <= $length; $rand++) {
		$random = rand(0, count($chars) - 1);
		$randstr .= $chars[$random];
	}
	return $randstr;
}

function DBG_GetBacktrace($traceArr)
{
	if ($sgbl->dbg < 0) {
		return;
	}

	$s = '';
	$MAXSTRLEN = 64;

	$s = '<pre align=left>';
	array_shift($traceArr);
	$tabs = sizeof($traceArr) - 1;
	foreach ($traceArr as $arr) {
		for ($i = 0; $i < $tabs; $i++) {
			$s .= ' &nbsp; ';
		}

		$tabs -= 1;
		$s .= '<font face="Courier New,Courier">';
		if (isset($arr['class'])) {
			$s .= $arr['class'] . '.';
		}
		$args = array();
		foreach ((array) $arr['args'] as $v) {
			if (is_null($v)) {
				$args[] = 'null';
			} else {
				if (is_array($v)) {
					$args[] = 'Array[' . sizeof($v) . ']';
				} else {
					if (is_object($v)) {
						$args[] = 'Object:' . get_class($v);
					} else {
						if (is_bool($v)) {
							$args[] = $v ? 'true' : 'false';
						} else {
							$v = (string) @$v;
							$str = htmlspecialchars(substr($v, 0, $MAXSTRLEN));
							if (strlen($v) > $MAXSTRLEN) $str .= '...';
							$args[] = "\"" . $str . "\"";
						}
					}
				}
			}
		}
		$s .= $arr['function'] . '(' . implode(',
        ', $args) . ')</font>';
		$Line = (isset($arr['line']) ? $arr['line'] : "unknown");
		$File = (isset($arr['file']) ? $arr['file'] : "unknown");
		$s .= sprintf("<font color=#808080 size=-1> # line
        %4d, file: <a href=\"file:/%s\">%s</a></font>", $Line, $File, $File);
		$s .= "\n";
	}
	$s .= '</pre>';
	return $s;
}

function getInfo($b)
{
	if (is_object($b) && is_subclass_of($b, 'lxclass')) {
		return $b->get__table() . ':' . $b->nname;
	} else {
		return $b;
	}
}

function backtrace_once()
{
	global $gbl, $sgbl, $login, $ghtml;
	if ($sgbl->dbg < 2) {
		return;
	}

	$v = debug_backtrace();
	$count = 0;
	$string = null;
	foreach ($v as $q) {
		$count++;
		if ($count === 1) {
			continue;
		}

		if ($count > 2) break;
		if ($count === 2 && (basename($q['file']) === 'sqlite.php')) {
			return null;
			continue;
		}
		$string .= $q['file'] . ":" . $q['line'] . ": " . $q['function'] . '(';
		if (isset($q['args'])) {
			foreach ($q['args'] as $a) {
				if (is_array($a)) {
					foreach ($a as $b) {
						if (is_array($b)) {
							foreach ($b as $c) {
								$string .= ', ' . getInfo($c);
							}
						} else {
							$string .= ', ' . getInfo($b);
						}
					}
				} else {
					$string .= $a;
				}
			}
		}
		$string .= ")<br>\n";
	}

	return $string;
}

function debugBacktrace($flag = false)
{
	global $gbl, $sgbl, $login, $ghtml;
	$string = null;

	if ($sgbl->dbg < 2) {
		return;
	}
	$v = debug_backtrace();
	foreach ($v as $q) 
	{
		$line = (isset($q['line'])) ? $q['line'] : '';
		$file = (isset($q['file'])) ? $q['file'] : '';
		$function = (isset($q['function'])) ? $q['function'] : '';
		
		$string .= $file . ":" . $line . ": " . $function . '(';
		
		if (isset($q['args'])) 
		{
			foreach ($q['args'] as $a) {
				if (is_array($a)) {
					foreach ($a as $b) {
						if (is_array($b)) {
							foreach ($b as $c) {
								$string .= ', ' . getInfo($c);
							}
						} else {
							$string .= ', ' . getInfo($b);
						}
					}
				} else {
					if (is_string($a)) {
						$string .= $a;
					}
				}
			}
		}
		$string .= ")<br>\n";
	}
	if ($flag) {
		return $string;
	}

	dprintr($string);
}

function lx_strip_tags($str)
{
	$nstr = strip_tags($str);

	$nstr = preg_replace("/\s+/", " ", $nstr);
	return $nstr;
}

class Language_Mes
{

}

function get_language()
{
	global $gbl, $sgbl, $login, $ghtml;
	if (is_object($login) && isset($login->getSpecialObject('sp_specialplay')->language)) {
		$lan = $login->getSpecialObject('sp_specialplay')->language;
	} else {
		$lan = 'en';
	}
	return $lan;
}

function get_charset()
{
	$lang = get_language();
	$charset = @ lfile_get_contents("lang/$lan/charset");
	$charset = trim($charset);
	return $charset;
}

function print_meta_lan()
{
	echo '<head>'.
    '    <meta http-equiv="Content-Type" content="text/html;charset=utf-8" />';
}

function init_language()
{
	global $gbl, $sgbl, $login, $ghtml;
	global $g_language_mes, $g_language_desc;

	$lan = get_language();

	if ($lan === 'en') {
		include_once "htmllib/lib/messagelib.php";
		include_once "htmllib/lib/helplib.php";
		include_once "htmllib/lib/helpvarlib.php";
		include_once "lib/messagelib.php";
		include_once "htmllib/lib/langfunctionlib.php";
		include_once "htmllib/lib/langkeywordlib.php";
	} else {
		if (lxfile_exists("lang/$lan/messagelib.php"))
		include_once "lang/$lan/messagelib.php"; else
		include_once "htmllib/lib/messagelib.php";

		if (lxfile_exists("lang/$lan/langfunctionlib.php")) {
			include_once "lang/$lan/langfunctionlib.php";
		} else {
			include_once "htmllib/lib/langfunctionlib.php";
		}

		if (lxfile_exists("lang/$lan/langkeywordlib.php")) {
			include_once "lang/$lan/langkeywordlib.php";
		} else {
			include_once "htmllib/lib/langkeywordlib.php";
		}
	}

	include_once "htmllib/lib/commonmessagelib.php";

	$g_language_mes = new Language_Mes();
	/*$g_language_mes->__information = $__information;
	 $g_language_mes->__emessage = $__emessage;
	$g_language_mes->__keyword = $__keyword;
	$g_language_mes->__help = $__help;
	$g_language_mes->__helpvar = $__helpvar;
	$g_language_mes->__commonhelp = $g_commonhelp;*/

	if ($lan === 'en') {
		//return;
	}
	include_once "lang/$lan/desclib.php";
	$g_language_desc = new Remote();
	//$g_language_desc->__description = $__description;
	//$g_language_desc->__acdescription = $__acdescription;
}

function lx_error_handler($errno, $errstr, $file, $line)
{
	global $gbl, $sgbl, $login, $ghtml;
	global $last_error;

	$last_error = $errstr;

	if ($sgbl->getDebugLevel() < 0) {
		return;
	}

	if (error_reporting() === 0) {
		return;
	}

	static $error = "";
	$pos = "$file:$line: $errstr";
	$error .= $pos . "\n";
	lfile_put_contents($sgbl->__var_error_file, $error);

	dprint("\n### PHP Error detected\n");
	dprint("### Notice: $errstr\n");
	dprint("### File:$file\n");
	dprint("### Line number: $line\n");
	dprint("### End PHP Error information\n\n");
}

/**
 * @return void
 * @param
 * @param
 * @desc Truly random and insane way to encrypt the image/form names so that hackers won't easily understand teh program structure, (which is clearly visible in these names...)
 */
function createEncName($name)
{
	global $gbl;

	return $name;

	if ($sgbl->dbg > 0) {
		return $name;
	}

	$name = str_replace("_", "", $name);
	$name = str_replace("php", "", $name);
	$name = str_replace("a", "r", $name);
	$name = str_replace("e", "z", $name);
	$name = str_replace("i", "q", $name);
	$name = str_replace("o", "j", $name);
	$name = str_replace("t", "y", $name);
	$name = str_replace("s", "x", $name);
	$name = str_replace("r", "p", $name);

	return $name;
}

function check_password($unenc, $enc)
{
	//Old Stuff Not reached
	if (crypt($unenc, $enc) === $enc) {
		return true;
	}

	return false;
}

function lx_exception_handler($e)
{
	global $gbl, $sgbl, $login, $ghtml;

	print("Notice : The resource you have requested doesn't exist. The server returned the error message: <br> ");

	print(" {$e->getMessage()} $e->variable $e->value ");
	print("<br>\n\n");

	if ($sgbl->dbg <= 0) {
		return;
	}
	$tr = $e->getTrace();
	$trace = "";
	foreach ($tr as $a) {
		$trace .= $a["file"] . ":" . $a["line"] . ":";
		if (isset($a["class"])) {
			$trace .= $a["class"] . ":";
		}
		$trace .= $a["function"] . "(";
		if (isset($a["args"])) {
			//$trace .= implode(",", $a['args']);
		}
		$trace .= ")\n";
	}
	lfile_put_contents($sgbl->__var_error_file, $trace);
}

function check_raw_password($class, $client, $pass)
{
	//return true;

	if (!$class || !$client || !$pass)
	{
		return false;
	}

	$rawdb = new Sqlite(null, $class);
	$password = $rawdb->rawquery("SELECT password FROM $class WHERE nname = '$client'");
	$enp = $password[0]['password'];

	if ($enp && check_password($pass, $enp))
	{
		return true;
	}
	return false;
	//$rawdb->close();
}

/**
 * @return void
 * @param
 * @param
 * @desc  Checks if the client is disabled and exits immedeiately showing a message.
 */
function check_if_disabled_and_exit()
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!$login->isOn('cpstatus'))
	{
		$current_session = $gbl->getCurrentSession();
		 
		Utmp::updateUtmp($current_session->nname, $login, 'disabled');

		$ghtml->print_css_source('/htmllib/css/common.css');
		$ghtml->__http_vars['frm_emessage'] = 'This login has been Disabled. Please contact the administrator';
		$ghtml->print_message();

		$current_session->delete();
		$current_session->was();

		exit(0);
	}
}

function delete_expired_ssessions()
{
	global $gbl, $sgbl, $login, $ghtml;

	$s_l = $login->getList('ssessionlist');

	if(!empty($s_l))
	{
		foreach ($s_l as $s) 
		{
			if (!is_object($s)) 
			{
				continue;
			}
			
			$timeout = $s->last_access + $login->getSpecialObject('sp_specialplay')->ssession_timeout;
			
			dprint($s->nname);
			
			if ($timeout < time()) 
			{
				$s->delete();
				Utmp::updateUtmp($s->nname, $login, 'Session Expired');
			}
		}
	}
}

/**
 * @return void
 * @param
 * @param
 * @desc A generic function, that can be used by all programs. Does all the basic login stuff.
 */
function initProgramlib($ctype = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	if ($sgbl->isSlave())
	{
		echo 'This is a Slave Server. Operate it at the Master server.' . PHP_EOL;
		exit;
	}

	$progname = $sgbl->getProductName();
	lfile_put_contents($sgbl->__var_error_file, '');
	set_exception_handler('lx_exception_handler');
	//xdebug_disable();
	set_error_handler('lx_error_handler');

	//setcookie("XDEBUG_SESSION", "sess");

	if ($ctype === 'superadmin')
	{
		$sgbl->setDataBaseFile($sgbl->__path_supernode_db);
		$sgbl->__path_admin_pass = $sgbl->__path_super_pass;
		$sgbl->setAdminUser($sgbl->__var_super_user);
		$login = new SuperClient(null, null, 'superadmin', 'login', 'forced');
		$login->get();
		return;
	}
	else if ($ctype === 'guest')
	{
		$login = new Client(null, null, '____________', 'guest');
		$login->get();
		return;
	}
	elseif ($ctype != '')
	{
		$login = new Client(null, null, $ctype, 'login', 'forced');
		$login->get();
		return;
	}

	$sessobj = NULL;

	if ($ghtml->frm_consumedlogin === 'true')
	{
		$clientname = $_COOKIE["$progname-consumed-clientname"];
		$classname = $_COOKIE["$progname-consumed-classname"];
		$session_id = $_COOKIE["$progname-consumed-session-id"];
		get_login($classname, $clientname);
		$login->__session_id = $session_id;
		$sessobj = $login->getObject('ssession');
	}
	else
	{
		if (isset($_COOKIE["$progname-session-id"]))
		{
			$clientname = $_COOKIE["$progname-clientname"];
			$classname = $_COOKIE["$progname-classname"];
			$session_id = $_COOKIE["$progname-session-id"];
			
			// Supernode
			if ($classname === 'superclient')
			{
				$sgbl->setDataBaseFile($sgbl->__path_supernode_db);
				$sgbl->__path_admin_pass = $sgbl->__path_super_pass;
				$sgbl->setAdminUser($sgbl->__var_super_user);
			}
			
			// Slave node
			if($classname === 'slave') $sgbl->setDataBaseFile($sgbl->__path_slave_db);

			if($classname)
			{
				get_login($classname, $clientname);
				$login->__session_id = $session_id;
				$sessobj = $login->getObject('ssession');
			}
		}
	}

	if (!$sessobj || $sessobj->dbaction === 'add') 
	{
		if ($ghtml->frm_ssl) {
			$ssl = unserialize(base64_decode($ghtml->frm_ssl));
			$string = $ssl['string'];
			$ssl_param = $ssl['ssl_param'];
			$encrypted_string = base64_decode($ssl['encrypted_string']);
			if (!$string || !checkPublicKey($string, $encrypted_string)) {
				print("SSL Connection Failed <br> \n");
				exit;
			}
			$class = 'client';
			$clientname = 'admin';
			get_login($class, $clientname);
			do_login($class, $clientname, $ssl_param);

			$sessobj = $gbl->getCurrentSession();
			$sessobj->write();
			$sessobj->dbaction = 'clean';
		}
	}

	//avoid some php warnings
	if (isset($login))
	{
		$gbl->client = $login->nname;
		$gbl->client_ttype = $login->cttype;
	}

	//dprintr($login->hpfilter);

	// This means the session object got created fresh.
	if (!$sessobj || $sessobj->dbaction === 'add') 
	{
		//dprint("Session id is empty. Clearing cookies and redirect to login.");
		clear_all_cookie();
		$ghtml->print_redirect_self('/login/');
	}

	$gbl->setCurrentSession($sessobj);

	if ($login->getClName() !== $sessobj->parent_clname)
	{
		dprint_r($login->ssession_l);
		dprint(" <br> $session_id <br> <br> <br> ");

		print("Session error! Login again.");

		clear_all_cookie();
		$ghtml->print_redirect_self('/login/?frm_emessage=sessionname_not_client');
	}

	$gen = $login->getObject('general')->generalmisc_b;

	if (!$gen->isOn('disableipcheck') && $_SERVER['REMOTE_ADDR'] != $sessobj->ip_address) 
	{
		$hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
		log_message("An attempt to hack from $hostname (" . $_SERVER['REMOTE_ADDR'] . ") with sess $sessobj->nname, session ip: $sessobj->ip_address");

		if (!$gen->isOn('disableipcheck'))
		{
			clear_all_cookie();

			$current_session = $gbl->getCurrentSession();
			if ($current_session->ssl_param)
			{
				$current_session->delete();
				$current_session->write();
				$ghtml->print_redirect("{$current_session->ssl_param['backurl']}&frm_emessage=ipaddress_changed_amidst_session");
			}
			else
			{
				$ghtml->print_redirect_self("/login/?frm_emessage=ipaddress_changed_amidst_session");
			}
		}
	}

	if (intval($login->getSpecialObject('sp_specialplay')->ssession_timeout) <= 100) {
		$login->getSpecialObject('sp_specialplay')->ssession_timeout = 100;
		$login->setUpdateSubaction();
	}

	$timeout = $sessobj->last_access + $login->getSpecialObject('sp_specialplay')->ssession_timeout;
	$sessobj->timeout = $timeout;
	//$timeout  =  $sessobj->last_access + 4;
	$sessobj->last_access = time();
	$sessobj->setUpdateSubaction();

	if ($sessobj->auxiliary_id) {
		$aux = new Auxiliary(null, null, $sessobj->auxiliary_id);
		$aux->get();
		$login->__auxiliary_object = $aux;
	}

	if (time() > $timeout)
	{
		$sessobj->delete();
		$sessobj->write();
		//print("session error timeout");

		$current_session = $gbl->getCurrentSession();

		if ($current_session->ssl_param)
		{
			$ghtml->print_redirect("{$current_session->ssl_param['backurl']}&frm_emessage=session_timeout");
		}
		else
		{
			$ghtml->print_redirect_self('/login/?frm_emessage=session_timeout');
		}
	}

	addToUtmp($sessobj, 'update');
}

function clear_all_cookie()
{
	global $gbl, $sgbl, $login, $ghtml;

	$search = $sgbl->getProductName();

	if ($ghtml->frm_consumedlogin === 'true')
	{
		$search .= "-consumed";
	}

	foreach ($_COOKIE as $k => $v)
	{
		if (csb($k, $search))
		{
			setcookie($k, '', time() - 360000000);
		}
	}
}

function checkPublicKey($string, $encrypted_string)
{
	echo 'Checking public key' . PHP_EOL;

	$res = lfile_get_contents("__path_program_root/etc/authorized_keys");
	$public_key = $res;
	$pubkey_res = openssl_get_publickey($public_key);
	openssl_public_decrypt($encrypted_string, $decrypted_string, $public_key);

	if ($decrypted_string === $string)
	{
		return true;
	}

	return false;
}

function initSession($object, $ssl_param, $consuming_parent)
{
	global $gbl, $sgbl, $login, $ghtml;
	
	$session = randomString(50);
	$timestamp = time();
	//clear_all_cookie();
	// Making cookie persistent, otherwise IE will not pass it to new windows.
	// Needed in the file selector. Set the expiration to 10 years in the future.
	// Needed for brain damaged ie, which cannot recognize server time.
	$cookietime = $timestamp + 24 * 60 * 60 * 365 * 80;
	//$cookietime = 0;
	header('P3P: CP="CAO PSA OUR"');

	$progname = $sgbl->getProductName();
	$cookie_start = $progname;

	if ($consuming_parent) 
	{
		$cookie_start .= "-consumed";
	}

	if ($object->isAuxiliary()) 
	{
		$name = $object->__auxiliary_object->nname;
		$class = $object->__auxiliary_object->getClass();
	} 
	else 
	{
		$name = $object->nname;
		$class = $object->getClass();
	}

	setcookie("$cookie_start-clientname", $name, $cookietime, '/');
	setcookie("$cookie_start-classname", $class, $cookietime, '/');
	setcookie("$cookie_start-session-id", $session, $cookietime, '/');

	//dprint("Set cookies<br/>");

	$sessa['nname']            = $session;
	$sessa['ip_address']       = $_SERVER['REMOTE_ADDR'];
	$sessa['cttype']           = $object->getLoginType();
	$sessa['hostname']         = $_SERVER['REMOTE_ADDR']; // Hostname
	$sessa['tsessionid']       = randomString(30);
	// Login time is set to null.
	// This is set to the correct time inside display.php.
	// This allows us to figure out the first run of display.php.
	$sessa['logintime']        = $timestamp;
	$sessa['ssession_vars']    = array();
	$sessa['http_vars']        = array();
	$sessa['parent_clname']    = $object->getClName();
	$sessa['consuming_parent'] = $consuming_parent;
	$sessa['auxiliary_id']     = $object->getAuxiliaryId();
	$sessa['ssl_param']        = $ssl_param;
	
	if (intval($object->getSpecialObject('sp_specialplay')->ssession_timeout) <= 100)
	{
		$timeout = 100;
	}
	else
	{
		$timeout = $object->getSpecialObject('sp_specialplay')->ssession_timeout;
	}
	
	$sessa['timeout']     = $timestamp + $timeout;
	$sessa['last_access'] = $timestamp;
	
	$current_session = new Ssession(null, null, $session);
	$current_session->create($sessa);

	return $current_session;
}

function do_login($classname, $cgi_clientname, $ssl_param = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!$classname)
	{
		$classname = 'client';
	}

	$current_session = initSession($login, $ssl_param, NULL);

	$gbl->setCurrentSession($current_session);

	$login->addToList('ssession', $current_session);

	addToUtmp($current_session, 'add');

	if ($ghtml->frm_extra_var)
	{
		$extra = unserialize(base64_decode($ghtml->frm_extra_var));
		$gbl->setSessionV('extra_var', $extra);
	}
	
	//This is not the way. You have to periodically scan the utmp and delete eveyrthing that had expired.
	delete_expired_ssessions();
}

function isModifyAction()
{
	global $gbl, $sgbl, $login, $ghtml;
	if (array_search_bool(strtolower($ghtml->frm_action), array('show', 'updateform', 'addform', 'continue', 'list')) || array_search_bool($ghtml->frm_subaction, array("download"))) {
		return false;
	}
	return true;
}

/**
 * Get the lowercase class of a object
 * @param object $object The object
 * @return string The lowercase name of a object
 */
function lget_class($object)
{
	return strtolower(get_class($object));
}

/** Seems not used anymore, but could be useful
 * on other scripts o for script factory
 * Enter description here ...
 * @param unknown_type $cttype
 * @return Ambigous <number, NULL, string, mixed>
 */
function getAllclients($cttype = null)
{
	$db = new Sqlite(null, 'client');

	$list = $db->getTable(array('nname', 'cttype'));

	return $list;
}

function isLocalhost($var)
{
	if ($var && $var !== 'localhost')
	{
		return false;
	}
	return true;
}

function get_login($classname, $clientname)
{
	global $gbl, $sgbl, $login, $ghtml;

	if (!$classname) {
		print("There is no class. Login Error\n");
		exit;
	}

	$object = new $classname(null, null, $clientname, 'login');

	$ret = $object->get();

	if ($classname === 'auxiliary') {
		$login = $object->getParentO();
		$login->__auxiliary_object = $object;
	} else {
		$login = $object;
	}

	$login->__parent_o = null;
	return $ret;
}

/**
 * @return void
 * @param
 * @param
 * @desc  Remove unsavoury characters from a string so that it can be used as a variable.
 */
function fix_nname_to_be_variable($var)
{
	if (!$var) {
		return;
	}
	if (is_numeric($var[0])) {
		$var[0] = 'd';
	}
	$var = strtolower($var);
	return preg_replace("/[-\W ]/i", "_", $var);
}

function fix_nname_to_be_variable_without_lowercase($var)
{
	if (!$var) {
		return;
	}
	if (is_numeric($var[0])) {
		$var[0] = 'd';
	}
	return preg_replace("/[-\W ]/i", "_", $var);
}

function get_description($stuff)
{
	if (is_object($stuff))
	{
		$class = lget_class($stuff);
	}
	else
	{
		$class = $stuff;
	}

	$descr = get_classvar_description($class);
	return $descr[2];
}

function get_classvar_description($class, $var = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	global $g_language_desc;
	global $g_language_mes;

	//$var = fix_nname_to_be_variable($var);
	if (csb($var, "__"))
	{
		$dvar = $var;
	} else {
		if ($var) {
			$dvar = "__desc_$var";
		} else {
			$dvar = "__desc";
		}
	}

	$rvar = strfrom($dvar, "__desc_");
	$rvar = strfrom($rvar, "__acdesc_");

	$class = strtolower($class);
	$ret = get_real_class_variable($class, $dvar);

	if (!$ret) {
		return null;
	}
	$ret['help'] = $ret[2];
	if (cse($dvar, "_o") || cse($dvar, "_l")) {
		return $ret;
	}
	if (!$g_language_desc) {
		return $ret;
	}

	/*
	 if ($login->getSpecialObject('sp_specialplay')->isCoreLanguage()) {
	return $ret;
	}
	*/

	$k = trim($ret[2], "_\n ");
	if (isset($g_language_desc->__description[$k])) {
		$ret[2] = $g_language_desc->__description[$k][0];
		if (isset($g_language_mes->__helpvar[$rvar])) {
			$ret['help'] = $g_language_mes->__helpvar[$rvar];
		} else if (isset($g_language_mes->__help[$dvar])) {
			$ret['help'] = $g_language_desc->__help[$k];
		} else {
			$ret['help'] = $ret[2];
		}
	}
	return $ret;
}

function get_var_help($var)
{
	global $g_language_mes, $g_language_desc;
	$cvar = strtolower($var);
	if (isset($g_language_mes->__help[$cvar])) {
		return $g_language_mes->__help[$cvar];
	}
	return $var;
}

function get_real_class_variable($class, $var)
{
	//$var = fix_nname_to_be_variable($var);
	$rclass = $class;
	$rclass = ucfirst($rclass);

	if (!class_exists($rclass)) {
		dprint("$rclass doesn't exist\n");
		return null;
	}

	$variable = "$rclass::\$" . $var;
	return eval(" if (isset($variable)) { return $variable ; }  ");
}

function get_class_variable($class, $var)
{
	$rclass = $class;

	$var = fix_nname_to_be_variable($var);
	$class = ucfirst($class);
	/*
	 if (csa($class, '-')) {
	debugBacktrace();
	exit;
	}
	*/

	$variable = "$class::\$" . $var;
	return eval(" if (isset($variable)) { return $variable ; }  ");
}

function set_class_variable($class, $var, $val)
{
	$var = fix_nname_to_be_variable($var);
	$class = ucfirst($class);
	$variable = "$class::\$" . $var;
	return eval(" $variable = \$val ; ");
}

function createZeroString($n)
{
	$string = "";
	for ($i = 0; $i < $n; $i++) {
		$string .= "0";
	}
	return $string;
}

/**
 * @return void
 * @param
 * @param
 * @desc  Execs a method inside a class. Passes all the variables to it. See the use of 2 evals.. Check documentation for lx_redefine_func;
 */
function exec_class_method($class, $func)
{
	global $gbl, $sgbl, $login, $ghtml;

	$rclass = $class;

	$class = strtolower($class);

	//Arg getting string is a function that needs $start to be set.
	$start = 2;

	$arglist = array();
	for ($i = $start; $i < func_num_args(); $i++)
	$arglist[] = func_get_arg($i);

	// workaround for the following php bug:
	//   http://bugs.php.net/bug.php?id=47948
	//   http://bugs.php.net/bug.php?id=51329
	class_exists($class);
	// ---
	//dprint('Exec_class_method: Class:'. $class . 'Func:' . $func. 'Arglist');
	//print_r($arglist);
	return call_user_func_array(array($class, $func), $arglist);
}

function lxgettimewithoutyear($time)
{
	$curd = @ getdate(time());
	$date = @ getdate($time);

	//$month = ($date['month'] === $curd['month'])? "this Month": $date['month'];
	$month = substr($date['month'], 0, 3);

	if ($date['hours'] > 12) {
		$sess = "pm";
		//$hour = $date['hours'] - 12;
		$hour = $date['hours'];
	} else {
		$sess = "am";
		$hour = $date['hours'];
	}

	$minutes = $date['minutes'];

	if ($minutes < 10) {
		$minutes = "0" . $minutes;
	}

	$string = "$hour:$minutes {$date['mday']} $month";

	return $string;
}

function lxgettime($time)
{
	$curd = @ getdate(time());
	$date = @ getdate($time);

	$year = ($date['year'] === $curd['year']) ? "" : $date['year'];
	//$month = ($date['month'] === $curd['month'])? "this Month": $date['month'];
	$month = substr($date['month'], 0, 3);

	if ($date['hours'] > 12) {
		$sess = "pm";
		//$hour = $date['hours'] - 12;
		$hour = $date['hours'];
	} else {
		$sess = "am";
		$hour = $date['hours'];
	}

	$minutes = $date['minutes'];

	if ($minutes < 10) {
		$minutes = "0" . $minutes;
	}

	$string = $hour . ":" . $minutes . " " . $date['mday'] . " " . $month . " " . $year;

	return $string;
}

function if_search_continue($obj)
{
	global $gbl, $sgbl, $ghtml;
	if (isset($ghtml->__http_vars['frm_searchstring']) && !stristr($obj->{$obj->searchVar()}, $ghtml->frm_searchstring)) {
		return 1;
	} else {
		return 0;
	}
}

function add_disabled($list)
{
	$newlist[] = "--Disabled--";
	$newlist = lx_merge_good($newlist, $list);
	return $newlist;
}

function fix_disabled($value, $disabled_val)
{
	if ($value === "--Disabled--") {
		return $disabled_val;
	} else {
		return $value;
	}
}

function array_remove_assoc(&$array, $element)
{
	foreach ($array as $key => $value) {
		if ($value === $element)
		unset($array[$key]);
	}
}

function array_remove_object($objectlist, $variable, $value)
{
	foreach ($objectlist as $object) {
		if ($object->$variable != $value) {
			$ret[$object->nname] = $object;
		}
	}
	return $ret;
}

function add_slave($pass)
{
	global $gbl, $sgbl, $login, $ghtml;

	$client = new Slave(null, null, 'slave');
	$client->initThisDef();

	$ddb = new Sqlite(null, 'slave');

	if (!$ddb->existInTable('nname', 'slave'))
	{
		$res['password'] = $pass;
		$res['cttype'] = 'slave';

		if (if_demo())
		{
			$res['email'] = "admin@example.org";
		}

		$client->create($res);
		$client->write();
	}
}

function pad_to_length($var, $len)
{
	$times = round(strlen($var) / $len) + 1;
	$in = str_pad($var, 2048 * $times - strlen($var));
	return $in;
}

function remote_http_exec($server, $port, $rmt)
{
	$var = base64_encode(serialize($rmt));
	$res = send_to_some_http_server($server, "", $port, $var);

	$res = unserialize(base64_decode($res));

	if ($res->exception) {
		throw $res->exception;
	}
	return $res->ddata;
}

function send_to_some_http_server($raddress, $socket_type, $port, $var)
{
	global $gbl, $sgbl, $login, $ghtml;

	print_time('server');

	$ch = curl_init("http://$raddress:$port/lbin/remote.php");
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
	curl_setopt($ch, CURLOPT_POSTFIELDS, "frm_rmt=$var&");
	$totalout = curl_exec($ch);
	dprint(curl_error($ch));
	$totalout = trim($totalout);
	return $totalout;
}

function check_remote_pass($user, $pass)
{
	global $gbl, $sgbl, $login, $ghtml;
	return check_password($pass, $login->password);
}

function lfile($arg)
{
	return lx_redefine_func("file", $arg);
}

function getNthToken($string, $num, $delim = ':')
{
	if (csa($string, $delim)) {
		$_tlist = explode($delim, $string);
		return $_tlist[$num];
	}
	return $string;
}

/**
 * @return void
 * @param unknown
 * @param unknown
 * @desc Recurses a dir tree and execs the '$func' on all the files AND the directories.
 */
function recurse_dir($dir, $func, $arglist = null)
{
	$list = lscandir($dir);
	if (!$list) {
		return;
	}
	foreach ($list as $file) {
		if ($file === "." || $file === "..") {
			continue;
		}
		$path = $dir . "/" . $file;
		if (lis_dir($path)) {
			recurse_dir($path, $func, $arglist);
		}
		/// After a successfuul recursion, you have to call the $func on the directory itself. So $func is called whether $path is both directory OR a file.
		$narglist[] = $path;
		foreach ((array) $arglist as $a) {
			$narglist[] = $a;
		}
		call_user_func_array($func, $narglist);
	}
}

function do_recurse_dir($dir, $func)
{
	$list = lscandir($dir);
	if (!$list) {
		return;
	}
	foreach ($list as $file) {
		if ($file === "." || $file === "..") {
			continue;
		}
		$path = $dir . "/" . $file;
		if (lis_dir($path)) {
			do_recurse_dir($path, $func);
		}
		$func($path);
	}
}

function getFromAny($list, $class, $name)
{
	$v = null;
	foreach ($list as $ob) {
		if (!$ob) {
			continue;
		}
		try {
			$v = $ob->getFromList($class, $name);
			return $v;
		} catch (exception $e) {
		}
	}
	return $v;
}

function array_get_object($objectlist, $variable, $value)
{
	foreach ($objectlist as $object)
	if ($object->$variable === $value) {
		return $object;
	}

	return NULL;
}

function getBasicServiceList()
{
	global $gbl, $sgbl, $login, $ghtml;
	$serv[] = $sgbl->__var_programname_web;
	$descr[$sgbl->__var_programname_web] = "Web Server";
	$serv[] = $sgbl->__var_programname_dns;
	$descr[$sgbl->__var_programname_dns] = "Name Server";
	$serv[] = "lxmail";
	$descr['lxmail'] = "Mail Server";
	return array($serv, $descr);
}

function getDbvariable($listvar, $mainvar)
{
	static $var;

	if (!$var) {
		$var = unserialize(lfile_get_contents("__path_dbschema"));
	}

	if (isset($var[$listvar][$mainvar])) {
		return $var[$listvar][$mainvar];
	} else {
		dprint("NO schema for $listvar $mainvar <br> \n");
		return null;
	}
}

function check_file_if_owned_by($file, $user)
{
	if (!lxfile_exists($file)) {
		return true;
	}

	if (csa($user, ":")) {
		$ruser = strtil($user, ":");
	} else {
		$ruser = $user;
	}
	$stat = lxfile_stat($file, false);
	$uid = $stat['uid'];
	$name = os_get_user_from_uid($uid);
	if ($name === $ruser) {
		return true;
	}
	log_log("file_check", "$file not owned by $ruser");
	return false;
}

function change_db_pass()
{
	global $gbl, $sgbl, $login, $ghtml;
	
	$pass = randomString(10);
	$newp = client::createDbPass($pass);
	$oldpass = lfile_get_contents("__path_admin_pass");

	$username = $sgbl->getProductName();

	$sql = new Sqlite(null, 'client');

	//$sql->rawQuery("grant all on kloxo.* to kloxo@'localhost' identified by $newp");
	//$sql->rawQuery("grant all on kloxo.* to kloxo@'%' identified by $newp");
	//$return = $sql->setPassword($newp);
	//exec("mysqladmin -u $username -p$oldpass password $newp 2>&1", $out, $return);

	exec("echo 'set Password=Password(\"$newp\")' | mysql -u $username -p$oldpass 2>&1", $out, $return);

	if ($return)
	{
		$out = implode(" ", $out);
		log_log('admin_error', "mysql change password Failed $out");
		throw new lxException ('could_not_change_admin_pass', '', $out);
	}

	$return = lfile_put_contents("__path_admin_pass", $newp);

	if (!$return)
	{
		log_log("admin_error", "Admin pass change failed  $last_error");
		throw new lxException ("could_not_change_admin_pass", '', $last_error);
	}
}

function create_database()
{
	global $gbl, $sgbl, $login, $ghtml;

	$flist = parse_sql_data();

	foreach ($flist as $k => $v)
	{
		create_table_with_drop($k, $v);
	}
}

function get_default_fields()
{
	$fields = array("nname", "parent_clname", "parent_cmlist");
	return $fields;
}

function parse_sql_data()
{
	global $gbl, $sgbl, $argc, $argv;

	static $_quota_var, $_field_var;

	$_return_value = null;

	$majmin = $sgbl->__ver_major_minor;
	$trel = $sgbl->__ver_release;

	$rpath = "sql/full.lxsql";
	$pathc = "htmllib/sql/common.lxsql";
	include $rpath;
	include $pathc;

	$string = $gl_sql_string_common . "\n" . $gl_sql_string;
	$string = explode("\n", $string);

	foreach ($string as $__k => $res) {
		$res = trim($res);
		if (!$res)
		continue;

		if (char_search_beg($res, "//")) {
			continue;
		}

		$res = preg_replace('/\s+/', " ", $res);

		if (csb($res, "#")) {
			$vl = explode(" ", $res);
			$name = array_shift($vl);
			$name = strfrom($name, "#");
			$nvl = null;
			$nnvl = null;
			foreach ($vl as $k => $qv) {
				if (csb($qv, "#")) {
					$_t = strfrom($qv, "#");
					$nvl = lx_array_merge(array($nvl, $_quota_var[$_t]));
				} else {
					$nvl[] = $qv;
				}
			}

			foreach ($nvl as $qv) {
				$nnvl[] = "priv_q_" . $qv;
				$nnvl[] = "used_q_" . $qv;
			}

			$_quota_var[$name] = $nvl;
			$g_qvar[$name] = $nnvl;
			$list = get_class_for_table($name);
			foreach ((array) $list as $l) {
				$_quota_var[$l] = $nvl;
				$g_qvar[$l] = $nnvl;
			}

			continue;
		}

		if (csb($res, "%")) {
			$vl = explode(" ", $res);
			$name = array_shift($vl);
			$nnnnvl = null;
			foreach ($vl as $q) {
				if (csb($q, "%")) {
					$nnnnvl = lx_array_merge(array($nnnnvl, $g_var[$q]));
				} else {
					$nnnnvl[] = $q;
				}
			}
			$g_var[$name] = $nnnnvl;
			continue;
		}

		$list = explode(" ", $res);
		$nlist = null;
		foreach ($list as $k => $l) {
			if (csb($l, "%")) {
				$nlist = array_merge($nlist, $g_var[$l]);
			} else {
				$nlist[] = $l;
			}
		}

		//dprintr($list);
		$list = $nlist;
		$nlist = null;
		foreach ($list as $l) {
			if ($l === '__q_var') {
				if (isset($g_qvar[$list[0]])) {
					$nlist = lx_array_merge(array($nlist, $g_qvar[$list[0]]));
				}
			} else {
				$nlist[] = $l;
			}
		}

		$list = $nlist;

		//dprintr($list);

		$name = array_shift($list);

		$fields = lx_array_merge(array(get_default_fields(), $list));
		if (array_search_bool("syncserver", $fields)) {
			$fields[] = 'oldsyncserver';
			$fields[] = 'olddeleteflag';
		}

		$fields = array_unique($fields);
		$_field_var[$name] = $fields;
		$_return_value[$name] = $fields;
	}

	foreach ($_quota_var as &$__tq) {
		$__tq = array_flip($__tq);
	}
	foreach ($_field_var as &$__tq) {
		$__tq = array_flip($__tq);
	}
	$var['quotavar'] = $_quota_var;
	$var['fieldvar'] = $_field_var;

	lfile_put_contents("__path_dbschema", serialize($var));
	return $_return_value;
}

function create_table_with_drop($table, $list)
{
	global $gbl, $sgbl, $login, $ghtml;
	 
	$database = new Sqlite(null, 'sqlite');
	 
	$database->rawQuery('DROP TABLE ' . $table);
	 
	create_table($database, $table, $list);
}

function create_table($database, $table, $list)
{
	global $gbl, $sgbl, $login, $ghtml;
	$database = new Sqlite(null, 'sqlite');

	if ($sgbl->__var_database_type === 'mysql')
	{
		$primary_key = "NOT NULL";
	}

	foreach ($list as &$__tl) {
		if (csb($__tl, "nname")) {
			$__tl = "$__tl varchar(255) $primary_key";
		} else if (csb($__tl, "ser_")) {
			$__tl = "$__tl longtext";
		} else if (csb($__tl, "coma_")) {
			$__tl = "$__tl text";
		} else if (csb($__tl, "text_")) {
			$__tl = "$__tl longtext";
		} else if (csb($__tl, "parent_cmlist")) {
			$__tl = "$__tl text";
		} else {
			// Why this madness... How can the general type be varchar. What will happen to all the text messages?
			$__tl = "$__tl varchar(255)";
		}
	}

	if ($sgbl->__var_database_type === 'mysql')
	{
		mysql_do_create_table($database, $table, $list);
	}
	else
	{
		sqlite_do_create_table($database, $table, $list);
	}
}

function sqlite_do_create_table($__db, $tbl_name, $fields)
{
	$fields = implode(', ', $fields);
	//$query = "create table $tbl_name ($fields, primary key (nname (255)));";
	$query = "create table $tbl_name ($fields);";
	print("Creating table $tbl_name....\n");
	$ret = $__db->rawQuery($query);
	//if (!$ret) {
	//print("\nerror: " . sqlite_error_string(sqlite_last_error()) . "\n\n");
	//}
	$query = "INSERT INTO $tbl_name (nname) values ('__dummy__dummy__')";
	$__db->rawQuery($query);
	//$query = "create index parent_clname_$tbl_name on $tbl_name (parent_clname (255));"; $__db->rawQuery($query);
}

function mysql_do_create_table($database, $table, $fields)
{
	$fields = implode(', ', $fields);
	$query = "CREATE TABLE $table ($fields, primary key (nname (255)));";
	 
	print("Creating table $table....\n");
	$ret = $database->rawQuery($query);
	 
	if (!$ret) {
		//print("\nerror: " . mysql_error() . "\n\n");
	}
	 
	$query = "create index parent_clname_$table on $table (parent_clname (255));";
	 
	$database->rawQuery($query);
}

// string_main();

function getQuotaListForClass($stuff, $res = null)
{
	if (is_object($stuff)) {
		$ob = $stuff;
	} else {
		$class = $stuff;
		$name = '__dummy__dummy__';
		$ob = new $class(null, null, $name);
		if ($res) {
			$ob->create($res);
		}
		$ob->priv = new Priv(null, null, $name);
	}
	return $ob->getQuotaVariableList();
}

function lx_xdebug_break()
{
	if (function_exists('xdebug_break')) {
		xdebug_break();
	}
}

function remove_extra_slash($file)
{
	return preg_replace("/\/+/", "/", $file);
}

function if_demo_throw_exception($where = null)
{
	global $gbl, $sgbl, $login, $ghtml;

	if ($sgbl->dbg < 0) {
		$where = null;
	}

	if (if_demo()) {
		throw new lxException("$where not_allowed_in_demo_version");
	}
}

function get_package_version($name)
{
	$cont = curl_general_get("http://download.lxcenter.org/download/version/$name");
	return trim($cont);
}

function getClassFromName($cgi_clientname)
{
	$classname = "client";

	if (csa($cgi_clientname, "@")) {
		$classname = "mailaccount";
	} elseif (csa($cgi_clientname, ".vps")) {
		$classname = "vps";
	} elseif (csa($cgi_clientname, ".vm")) {
		$classname = "vps";
	} elseif (csa($cgi_clientname, ".aux")) {
		$classname = "auxiliary";
	}
	/*
	 Domain user doesn't exist anymore....
	else if (csa($cgi_clientname, ".")) {
	$classname = "domain";
	}
	*/
	return $classname;
}

/* This is the only function that executes during the initialization.
The rest of the whole library exists as functions that can be called.
Nothing gets executed on their own, except this.
So it makes this sort of special */

if(!isset($sgbl)) $sgbl = new Sgbl();

if(!isset($gbl))
{
	require_once('lib/gbl.php');
	$gbl = new Gbl();
}

$gbl->get();

# [FIXME] Better call to a general isDemo function()
# Turn on demo version by putting a empty file called demo in the etc dir
if(lfile_exists($sgbl->getEtc() . '/demo')) $g_demo = 1;

check_for_debug('/commands.php');

#[FIXME] Use $sgbl::DEBUG_LITE instead 1 when we can use PHP 5.3.0
$sgbl->setMethod(($sgbl->getDebugLevel() >= 1) ? 'get' : 'post');