<?php
include_once 'htmllib/lib/include.php';
include_once 'htmllib/lib/initlib.php';
include_once '../bin/install/init.php';

class MakeMaster
{
	private $argv      = NULL;
	private $options   = NULL;
	private $password  = NULL;
	
	public function __construct()
	{
		$this->checkRoot();
	}
	
	private function checkRoot()
	{
		require_once 'htmllib/lib/linux/lib.php';
		
		if(!os_isSelfSystemOrLxlabsUser()) 
		{ 
			echo 'Must be Root ' . PHP_EOL;
			exit;
		}
	}
	
	private function checkUsage()
	{
		// Define params
		$params  = array(
				    	 'password:', // Required value: [password]
						);
		
		// Get options
		$this->options = getopt(NULL, $params);
		
		// Check data
		if(!is_array($this->options) || empty($this->options))
		{
			$this->usage();
		}
		
		// Check password param
		if(!isset($this->options['password']) || empty($this->options['password']))
		{
			$this->password = 'admin';
		}
		
		$this->password = $this->options['password'];
	}
	
	private function usage()
	{
		echo 'Usage: makemaster --password password' . PHP_EOL .
			 'If not password is provided, default is \'admin\'' . PHP_EOL;
		exit(1);
	}
	
	public function run()
	{
		$this->checkUsage();
		
		global $argc, $argv;
		global $gbl, $sgbl, $login, $ghtml;
		$opt = parse_opt($argv);
		//var_dump($opt);

		$program = $sgbl->getProductName();
		
		$updater = new Updater();
		$updater->createMainPaths();
		$updater->fixLxlabsPermissions();
		$updater->createProgramService($program); //For kloxo right way
		$updater->createProgramService('qpanel'); //Temporal for qpanel
		$updater->copyPHPini();
		
		echo 'Making master' . PHP_EOL;
		create_mysql_db('master', $opt, $this->password);
		create_database();
		create_general();
		init_main($this->password);
		lxshell_return($sgbl->getPHPPath(), '../bin/collectquota.php');
		$updater->initCleanup('master');
		
		os_create_default_slave_driver_db();
	}
}