<?php
include_once 'htmllib/lib/include.php';
include_once 'htmllib/lib/initlib.php';
include_once '../bin/install/init.php';

class MakeSupernode
{
	private $argv      = NULL;
	private $options   = NULL;
	private $password  = NULL;
	
	public function __construct()
	{
		$this->checkRoot();
	}
	
	private function checkRoot()
	{
		require_once 'htmllib/lib/linux/lib.php';
		
		if(!os_isSelfSystemOrLxlabsUser()) 
		{ 
			echo 'Must be Root ' . PHP_EOL;
			exit;
		}
	}
	
	private function checkUsage()
	{
		// Define params
		$params  = array(
				    	 'password:', // Required value: [password]
						);
		
		// Get options
		$this->options = getopt(NULL, $params);
		
		// Check data
		if(!is_array($this->options) || empty($this->options))
		{
			$this->usage();
		}
		
		// Check password param
		if(!isset($this->options['password']) || empty($this->options['password']))
		{
			$this->password = 'admin';
		}
		
		$this->password = $this->options['password'];
	}
	
	private function usage()
	{
		echo 'Usage: makesupernode --password password' . PHP_EOL .
			 'If not password is provided, default is \'admin\'' . PHP_EOL;
		exit(1);
	}
	
	private function addSuperAdmin($pass)
	{
		global $gbl, $sgbl, $login, $ghtml;
		
		$client = new SuperClient(NULL, NULL, 'superadmin');
		$client->initThisDef();
		
		$database = new Sqlite(NULL, 'superclient');
		
		if (!$database->existInTable('nname', 'superclient'))
		{
			$res['password'] = crypt($pass);
			$res['cttype']   = 'superadmin';
			$res['cpstatus'] = 'on';
		
			if (if_demo())
			{
				$res['email'] = "admin@example.org";
			}
		
			$client->create($res);
			$client->write();
		}
	}
	
	private function initSupernode($pass)
	{
		create_database();
		create_general();
		$this->addSuperAdmin($pass);
	}
	
	public function run()
	{
		$this->checkUsage();
		
		global $argc, $argv;
		global $gbl, $sgbl, $login, $ghtml;
		$opt = parse_opt($argv);
		//var_dump($opt);

		$program = $sgbl->getProductName();
		
		$updater = new Updater();
		$updater->createMainPaths();
		$updater->fixLxlabsPermissions();
		$updater->createProgramService($program); //For kloxo right way
		$updater->createProgramService('qpanel'); //Temporal for qpanel
		$updater->copyPHPini();
		
		$sgbl->__path_sql_file = $sgbl->__path_sql_file_supernode;
		$sgbl->setDataBaseFile($sgbl->__path_supernode_db);
		$sgbl->setAdminFilePass($sgbl->getSuperFilePass());
		$sgbl->setAdminUser($sgbl->__var_super_user);
		
		create_mysql_db('super', $opt, $admin_pass);
		$this->initSupernode($admin_pass);
		echo "\n";
		
		os_create_default_slave_driver_db();
	}
}