<?php 

class Sgbl
{ # System GloBLals
    const PRODUCTION_MODE = -1;
    const NON_MODE        = 0;
    const DEBUG_LITE      = 1;
    const DEBUG_IMPORTANT = 2;
    const DEBUG_URGENT    = 3;
    const DEBUG_EXTREME   = 4;
    const DEBUG_ALL       = 5;

    const LOCAL_PORT      = 7776;
    const REMOTE_PORT     = 7779;
    
    function __construct()
    {
        # [FIXME] Unknow use of this attribute
        $this->arg_getting_string = '
        $arglist = array();
        $nargs = @func_num_args();
        if($nargs > 0)
            for ($i = $start; $i < $nargs; $i++)
                $arglist[] = (isset($transforming_func)) ? $transforming_func(func_get_arg($i)) : func_get_arg($i);
        ';
        
        $this->initBrandName();
        $this->initProductName();
        $this->createServiceDescriptions();
        $this->initVersionAttributes();
        $this->createGenericVars();
        $this->createCttypeVars(); # [FIXME] Unknown acronym, maybe ClienT Type = cctype?
        $this->createLtypeVars(); # [FIXME] Unknown acronym
        $this->initLanguageVars();
        $this->createPaths();

        ${'this->__var_' . $this->getBrandName() . '_marker'} = '__' . $this->getBrandName() . '_marker';
        
        $this->__var_local_port  = self::LOCAL_PORT;
        $this->__var_remote_port = self::REMOTE_PORT;

        $this->__var_progservice_apache = 'httpd';
        $this->__var_progservice_bind = 'named';
        
        $this->__var_programname_ftp = 'pure-ftpd';
        $this->__var_programname_syslog = 'syslog';
        //$this->__var_programname_mysql = 'mysqld';
        $this->__var_programname_mmail = 'qmail';
        $this->__var_programname_imap = 'courier-imap';
        $this->__var_programuser_dns = 'named';

        $this->__var_no_sync = false;
        $this->__var_exit_char = '___...___';
        $this->__var_remote_char = '_._';
        $this->__var_connection_type = 'tcp';

        $this->initMainConfig();
        
        $this->__path_dbschema = $this->getRoot() . '/file/.db_schema';

        $this->initDataBaseFile();
        $this->initPasswordFiles();

        $this->__var_super_user = 'lxasuper';
        $this->initAdminUser();

        $this->__path_slave_db = $this->getEtc() . 'conf/slave-db.db';
        //$this->__path_supernode_db = $this->__path_program_etc . "/conf/supernode-db.db";
        $this->__path_supernode_db = 'lxasuper';

        $this->__path_sql_file_supernode  = "$this->__path_program_htmlbase/sql/supernode";
        $this->__path_sql_file  = "$this->__path_program_htmlbase/sql/full";
        $this->__path_sql_file_common  = "$this->__path_program_htmlbase/sql/common";

        $this->__path_updating_file = $this->__path_program_etc . '/.updating';
        $this->__path_httpd_conf_file = $this->__path_apache_path . '/httpd.conf';
        $this->__path_mail_log = $this->__path_log . '/maillog';
        $this->__path_boot_log = $this->__path_log . '/boot.log';
        $this->__path_cron_log = $this->__path_log . '/cron';
        $this->__path_mysql_log = $this->__path_log . '/mysqld.log';
        $this->__path_vsftpd_log = $this->__path_log . '/vsftpd.log';
        $this->__path_lxmisc = $this->getRoot() . '/sbin/lxmisc';

        $this->__var_rolelist = array('web', 'mail', 'dns', 'secondary_master');
        //$this->__var_dblist = array("mysql", "pgsql");
        $this->__var_dblist = array('mysql');

        $this->__var_error_file = $this->getRoot() . '/httpdocs/.php.err';

        $this->__var_ticket_subcategory = null;
    }

    private function initBrandName()
    { # Init the brand name for the products
        $this->__brandname = 'lxlabs';
    }
    
    private function initProductName()
    { # Init the program name of the product
        $this->__var_program_name = 'kloxo';
    }

    private function createServiceDescriptions()
    { # Create the vars for service descriptions
        $this->__var_service_desc['httpd']        = 'Apache Web Server';
        $this->__var_service_desc['apache2']      = 'Apache Web Server';
        $this->__var_service_desc['qmail']        = 'Qmail Mail Server';
        $this->__var_service_desc['named']        = 'Bind Dns Server';
        $this->__var_service_desc['bind9']        = 'Bind Dns Server';
        $this->__var_service_desc['pure-ftpd']    = 'Pureftp Ftp Server';
        $this->__var_service_desc['courier']      = 'Courier Pop/Imap Server';
        $this->__var_service_desc['courier-imap'] = 'Courier Pop/Imap Server';
    }

    private function initVersionAttributes()
    { # Init the values for the program version attributes
        $this->__ver_major      = '6';
        $this->__ver_minor      = '1';
        $this->__ver_release    = '4';
        $this->__ver_enterprise = 'Single Server Edition';
        $this->__ver_type       = 'production';
        $this->__ver_extra      = 'Stable';
        #[FIXME] This two lines don't should be a atributte (rule: a atributte is not a composition of others), call to a method
        $this->__ver_major_minor = $this->__ver_major . '.' . $this->__ver_minor;
        $this->__ver_major_minor_release = $this->__ver_major . '.' . $this->__ver_minor . '.' . $this->__ver_release;
    }

    private function createGenericVars()
    { # [FIXME] Undocumented method
        $this->__var_nname_impstr  = '___'; #[FIXME] Unknow use
        #[FIXME] Harcorded ports, read from a file and set defaults if empty
        $this->__var_prog_port     = '7778';
        $this->__var_prog_ssl_port = '7777';
    }

    private function createCttypeVars()
    { # [FIXME] Undocumented method
        $this->__var_cttype = array();
        $this->__var_cttype['superadmin']  = 4;
        $this->__var_cttype['superclient'] = 5;
        $this->__var_cttype['node']        = 7;
        $this->__var_cttype['admin']       = 11;
        $this->__var_cttype['master']      = 15;
        $this->__var_cttype['wholesale']   = 20;
        $this->__var_cttype['reseller']    = 30;
        $this->__var_cttype['customer']    = 40;
        $this->__var_cttype['pserver']     = 50;
        $this->__var_cttype['domain']      = 60;
        $this->__var_cttype['uuser']       = 70;
        $this->__var_cttype['ftpuser']     = 80;
        $this->__var_cttype['mailaccount'] = 90;
    }

    private function createLtypeVars()
    { # [FIXME] Undocumented method
        $this->__var_ltype = array();
        $this->__var_ltype[$this->getProductName() . 'account'] = 'client';
        $this->__var_ltype['serveradmin']  = 'pserver';
        $this->__var_ltype['domainowner']  = 'domain';
        $this->__var_ltype['sysuser']      = 'uuser';
        $this->__var_ltype['mailuser']     = 'mailaccount';
        $this->__var_ltype['ftpuser']      = 'ftpuser';
        $this->__var_ltype['superclient']  = 'superclient';
    }

    private function initLanguageVars()
    { # Init the language vars values. [FIXME] This should be deprecated with gettext system
        $this->__var_language['tr'] = 'Turkish';
        $this->__var_language['en'] = 'English';
        $this->__var_language['cen'] = 'Custom English';
        $this->__var_language['cn'] = 'Chinese';
        $this->__var_language['es'] = 'Spanish';
        $this->__var_language['de'] = 'German';
        $this->__var_language['it'] = 'Italian';
        $this->__var_language['fr'] = 'French';
        $this->__var_language['cz'] = 'Czech';
        $this->__var_language['nl'] = 'Dutch';
        $this->__var_language['pt'] = 'Portuguese';
        $this->__var_language['pl'] = 'Polish';
        $this->__var_language['lt'] = 'Lithuanian';
        $this->__var_language['bg'] = 'Bulgarian';
        $this->__var_language['jp'] = 'Japanese';
        $this->__var_language['kr'] = 'Korean';
        $this->__var_language['ru'] = 'Russian';
        $this->__var_language['se'] = 'Swedish';
        $this->__var_language['ro'] = 'Romanian';
        $this->__var_language['br'] = 'Brazilian Portuguese';
    }

    private function createPaths()
    { # Create some config paths reading from file and detecting the operating system
    	$this->__var_quote_char = "'";
	    $this->__var_database_type = 'mysql';
	
	    $this->__path_tmp = '/tmp';
	    $this->__path_slash = '/';
	    $this->__path_user_root = '/usr';
	    $this->__path_var_root = 'var';
	    $this->__path_log = 'var/log';
	    $this->__path_root_base = '/';
	
	    $this->__path_mysqldump_path = 'mysqldump';
	    $this->__path_named_path = '/var/named';
	    $this->__path_named_conf = '/etc/' . $this->getProductName() . '.named.conf';
	    $this->__path_apache_path = '/etc/httpd/conf/';
	    $this->__path_mysql_datadir = '/var/lib/mysql/';
	    $this->__path_customer_root = '/home';
	    $this->__path_real_etc_root = '/etc';
	
	    $this->__path_program_home = '/home/' . $this->getProductName();
	    $this->__path_program_root = '/usr/local/' . $this->getBrandName() . '/' . $this->getProductName();
	    $this->__path_program_htmlbase = '/usr/local/' . $this->getBrandName() . '/' . $this->getProductName() . '/httpdocs';
	    $this->__path_program_etc = '/usr/local/' . $this->getBrandName() . '/' . $this->getProductName() . '/etc/';
	
	    $this->__path_home_dir = '/home';
	    $this->__path_client_root = '/home/' . $this->getProductName() . '/client';
	    ${'this->__path_' . $this->getProductName() . '_httpd_root'} = '/home/' . $this->getProductName() . '/httpd';
	    ${'this->__path_' . $this->getBrandName() . '_base'} = '/usr/local/' . $this->getBrandName();

    	$this->__path_mail_root = '/home/lxadmin/mail'; # [FIXME] Change lxadmin to lxlabs
    	$this->__path_httpd_root = '/home/httpd';
    	$this->__path_perl_path = '/usr/bin/perl';
    	$this->__path_php_path = ${'this->__path_' . $this->getBrandName() . '_base'} . '/ext/php/php';

    	# Only GNU/Linux
    	${'this->__path_' . $this->getProductName() . '_back_phpini'} = '/etc/' . $this->getProductName() . '-backup-php.ini';
    	$this->__path_mysqlclient_path = 'mysql';
    	$this->__var_noaccess_shell = '/sbin/nologin';

    	$this->__path_mara_path = '';
    	$this->__path_mara_chroot = '/etc/maradns/';
    	$this->__path_mara_conf = '/etc/mararc';

    	$this->__path_home_root = '/home/' . $this->getProductName();

    	$this->__path_lighty_path = '/etc/lighttpd/';
    	$this->__path_cron_root = '/var/spool/cron/';

        $this->__path_serverfile = ${'this->__path_' . $this->getBrandName() . '_base'} . '/' . $this->getProductName() . '/serverfile';
        $this->__path_download_dir = ${'this->__path_' . $this->getBrandName() . '_base'} . '/' . $this->getProductName() . '/download';

        $this->__path_program_start_vps_flag = $this->getRoot() . '/etc/flag/start_vps.flg';

        $this->__path_installapp_servervar = ${'this->__path_' . $this->getProductName() . '_httpd_root'} . '/installappdata/lx_template.servervars.phps';

        //Default Values that will be overrriden in the 'productname' conf file.
        $this->__path_named_chroot = '/var/named/chroot/';
        $this->__path_ssl_root = ${'this->__path_' . $this->getProductName() . '_httpd_root'} . '/ssl';
        $this->__path_named_realpath = $this->__path_named_chroot . '/$this->__path_named_path';
    }

    public function getDataBaseType()
    { # Return the database type for the program
        return (isset($this->__var_database_type)) ? $this->__var_database_type : NULL;
    }

    public function getBrandName($uppercase = false)
    { # Return the brand name for the program. The $uppercase params show the first letter uppercase if it is true
        if(isset($this->__brandname)) 
            return ($uppercase) ? ucfirst($this->__brandname): $this->__brandname;
        else return NULL;
    }
    
    public function getProductName($uppercase = false)
    { # Return the brand name for the program
        # [FIXME] Fix this for QPanel (QP upper), now only Q
        if(isset($this->__var_program_name))
            return ($uppercase) ? ucfirst($this->__var_program_name): $this->__var_program_name;
        else return NULL;
    }
    
    public function getHomeRoot()
    {
    	# Return the home root path for the program
    	return (isset($this->__path_home_root)) ? $this->__path_home_root : NULL;
    }
    
    public function getRoot()
    { # Return the root path for the program
        return (isset($this->__path_program_root)) ? $this->__path_program_root : NULL;
    }
    
    public function getEtc()
    { # Return the etc path for the program
        return (isset($this->__path_program_etc)) ? $this->__path_program_etc : NULL;
    }

    public function getHTMLBase()
    { # Return the HTML base path for the program
        return (isset($this->__path_program_htmlbase)) ? $this->__path_program_htmlbase : NULL;
    }

    public function getPHPPath()
    { # Return the php path for the php customized binary
        return (isset($this->__path_php_path)) ? $this->__path_php_path : NULL;
    }

    public function getProgramHome()
    { # Return the program home path for the program
    	return (isset($this->__path_program_home)) ? $this->__path_program_home : NULL;
    }
    
    public function getVersion()
    { # Return the full version for the program
        return (isset($this->__ver_major_minor_release)) ? $this->__ver_major_minor_release : NULL;
    }

    public function getMajorVersion()
    { # Return the major version for the program
        return (isset($this->__ver_major)) ? $this->__ver_major : NULL;
    }

    public function getMinorVersion()
    { # Return the minor version for the program
        return (isset($this->__ver_minor)) ? $this->__ver_minor : NULL;
    }

    public function getReleaseVersion()
    { # Return the release version for the program
        return (isset($this->__ver_release)) ? $this->__ver_release : NULL;
    }

    public function getlType($classname)
    { #[FIXME] Undocumented function
        return array_search($classname, $this->__var_ltype);
    }
    
    public function setDebug($level)
    { # Set the level of the debug mode the program. Default production mode
        switch($level)
        {
            case self::PRODUCTION_MODE:
            case self::NON_MODE:     
            case self::DEBUG_LITE:     
            case self::DEBUG_IMPORTANT:
            case self::DEBUG_URGENT:   
            case self::DEBUG_EXTREME:  
            case self::DEBUG_ALL:
                $this->dbg = $level;
            break;
    
            default:
                self::PRODUCTION_MODE;
                $this->dbg = $level; 
            break;
        }
    }
    
    public function isDebug()
    { # Checks if the debug mode is set for the program, i.e, no production mode
        return ($this->dbg > self::NON_MODE);
    }

    public function getDebugLevel()
    { # Get the debug level for the program.
        return (isset($this->dbg)) ? $this->dbg : self::PRODUCTION_MODE;
    }

    private function initMainConfig()
    { # Init dinamically some variables for services and paths what depends of the operating system
        # [FIXME] This way of init vars should be avoided (old behaviour)
        
        # Default Operating System config
        $conf['path']['apache_path']  = '/etc/httpd/conf/';
        $conf['path']['named_chroot'] = '/var/named/chroot';
        
        # If you have a chroot, the named path should be relative to the chroot directory.
        $conf['path']['named_path'] = '/var/named';
        $conf['path']['named_conf'] = '/etc/' . $this->getProductName() . '.named.conf';

        $conf['var_programname']['web']   = 'httpd';
        $conf['var_programname']['dns']   = 'named';
        $conf['var_programname']['mysql'] = 'mysqld';
        $conf['var_programuser']['dns']   = 'named';

        switch(findOperatingSystem('os'))
        {
            case 'debian':
                $conf['path']['named_chroot'] = '';
                $conf['var_program']['ipaddress'] = 'debian';
                $conf['var_program']['service'] = 'debian';
                $conf['var_programname']['web'] = 'apache2';
                $conf['var_programname']['dns'] = 'bind9';
                $conf['var_programname']['mysql'] = 'mysql';
                $conf['var_programuser']['dns'] = 'bind';
            break;
            case 'fedora': # All as default config
            break;
            case 'rhel': # All as default config
            break;
            case 'windows': # All as default config #[FIXME] Don't possible, no tested
            break;
        }

        foreach($conf as $key => $value)
        {
            foreach($value as $nkey => $nvalue)
            {
                $aux = '__' . $key . '_' . $nkey;
                $this->$aux = $nvalue;
            }
        }
    }
        
    private function initDataBaseFile()
    { # Init the database file for the program.
        $this->__database_file = ($this->getDataBaseType() === 'sqlite') ? $this->getEtc() . '/conf/db.db' : $this->getProductName();
    }

    public function setDataBaseFile($database_file)
    { # Set the database file for the program.
        $this->__database_file = $database_file;
    }

    public function getDataBaseFile()
    { # Get the database file for the program.
        return (isset($this->__database_file)) ? $this->__database_file : NULL;
    }

    private function initPasswordFiles()
    { # Init the paths for the files that store main passwords for the program 
        $this->__path_super_pass = $this->__path_program_etc . '/conf/superadmin.pass';
        $this->__path_admin_pass = $this->__path_program_etc . '/conf/' . $this->getProductName() . '.pass';
        $this->__path_master_pass = $this->__path_program_etc . '/conf/' . $this->getProductName() . '.pass';
    }

    public function getSuperFilePass()
    { # Get the super file password stored for the program.
        return (isset($this->__path_super_pass)) ? $this->__path_super_pass : NULL;
    }

    public function getAdminFilePass()
    { # Get the admin file password stored for the program.
        return (isset($this->__path_admin_pass)) ? $this->__path_admin_pass : NULL;
    }

    public function getMasterFilePass()
    { # Get the master file password stored for the program.
        return (isset($this->__path_master_pass)) ? $this->__path_master_pass : NULL;
    }

    public function setSuperFilePass($file)
    { # Set the file for the super file password stored for the program.
        $this->__path_super_pass = $file;
    }

    public function setAdminFilePass($file)
    { # Set the file for the admin file password stored for the program.
        $this->__path_admin_pass = $file;
    }

    public function setMasterFilePass($file)
    { # Set the file for the master file password stored for the program.
        $this->__path_master_pass = $file;
    }

    private function initAdminUser()
    { # Init the admin user for the program.
        $this->__admin_user = $this->getProductName();
    }

    public function setAdminUser($admin_user)
    { # Set the admin user for the program.
        $this->__admin_user = $admin_user;
    }

    public function getAdminUser()
    { # Get the admin user for the program.
        return (isset($this->__admin_user)) ? $this->__admin_user : NULL;
    }

    public function setMethod($method)
    { # Set the method for the program.
        $this->method = $method;
    }

    public function getMethod()
    { # Get the method for the program.
        return (isset($this->method)) ? $this->method : 'post';
    }
    
    public function getHTTPdRoot()
    { # Get the httpd root path for the program.
        return (isset($this->__path_httpd_root)) ? $this->__path_httpd_root : NULL;
    }
    
    public function getProductHTTPdRoot()
    { # Get the product httpd root path for the program.
    	return ${'this->__path_' . $this->getProductName() . '_httpd_root'} = '/home/' . $this->getProductName() . '/httpd';
    }
    
    public function getServerFilePath()
    { # Get the path server file for the program.
    	return $this->__path_serverfile;
    }
    
    # [FIXME] Exported method from sgbllib.php
    public function is_this_master()
    {
        return !$this->isSlave();
    }

    public function isSlave()
    {
        return lxfile_exists($this->__path_slave_db);
    }
}